<?php

// +---------------------------------------------+
// |     Copyright  2010 - 2018 InterPhoto       |
// |     http://www.weensoft.com                 |
// |     This file may not be redistributed.     |
// +---------------------------------------------+

include('includes/Admin.Core.php');

CheckAccess('managecomment');


PrintHeader('Comments');


$action = ForceIncomingString('action', 'displaycomments');
if(IsPost('updatecomments')) $action= 'updatecomments';
if(IsPost('deletecomments')) $action= 'deletecomments';

// ############################## FUNCTIONS #############################

function GetSearchSql($search, $actived) {
	$sWhere = '';
	if($search != ''){
		$sWhere .= " WHERE (username LIKE '%".$search."%' OR content LIKE '%".$search."%') ";

		if($actived == '1'){
			$sWhere .= " AND actived = '1' ";
		}elseif($actived == '-1'){
			$sWhere .= " AND actived = '0' ";
		}
	}elseif($actived == '1'){
		$sWhere .= " WHERE actived = '1' ";
	}elseif($actived == '-1' ){
		$sWhere .= " WHERE actived = '0' ";
	}

	return $sWhere;
}

// ################################ UPDATE COMMENT ################################

if($action == 'updatecomment')
{
	$commentid     = ForceIncomingInt('commentid');
	$username        = ForceIncomingString('username');
	$content        = ForceIncomingString('content');
	$actived     = ForceIncomingInt('actived');
	$deletecomment     = ForceIncomingInt('deletecomment');

	if ($deletecomment)
	{
		$DB->query("DELETE FROM " . TABLE_PREFIX . "comments WHERE commentid = '$commentid' ");
		PrintRedirect('admin.comments.php', 1);
	}

	if (strlen($username) == 0)
	{
		$errors[] = "The author of this comment is empty!";
	}

	if(strlen($content) == 0){
		$errors[] = "The content of this comment is empty!";
	}

	if(!isset($errors)){
		$DB->query("UPDATE " . TABLE_PREFIX . "comments SET 
		username     = '$username',
		content     = '$content',
		actived     = '$actived'
		WHERE commentid   = '$commentid'");

		PrintRedirect('admin.comments.php', 1);
	}else{
		PrintErrors($errors, 'Edit Comment Errors');
		$action = 'editcomment';
	}
}


// ############################### UPDATE COMMENTS ################################

if($action == 'updatecomments'){
	$commentids   = ForceIncomingArray('updatecommentids');
	$activeds   = ForceIncomingArray('activeds');

    for($i = 0; $i < count($commentids); $i++)
    {
		$DB->query("UPDATE " . TABLE_PREFIX . "comments SET	actived = '$activeds[$i]' WHERE commentid = '$commentids[$i]'");
    }

    PrintRedirect('admin.comments.php', 1);

}

// ############################### DELETE COMMENTS ################################

if($action == 'deletecomments')
{
	$deletecommentids = ForceIncomingArray('deletecommentids');

	for($i = 0; $i < count($deletecommentids); $i++){
		$DB->query("DELETE FROM " . TABLE_PREFIX . "comments WHERE commentid = '$deletecommentids[$i]' ");
	}

	PrintRedirect('admin.comments.php', 1);
}

// ############################ DISPLAY COMMENT FORM #############################

if($action == 'editcomment')
{
	$commentid = ForceIncomingInt('commentid');

	if(isset($errors))
	{
		$comment = array('commentid'   => $commentid,
			  'username'     => $username,
			  'content'     => $_POST['content'],
			  'actived'     => $actived);

	}elseif($commentid) {
		$comment = $DB->query_first("SELECT * FROM " . TABLE_PREFIX . "comments WHERE commentid = '$commentid'");
	}

	PrintSection('Edit Comment');

	echo '<form method="post" action="admin.comments.php">
	<input type="hidden" name="action" value="updatecomment" />
	<input type="hidden" name="commentid" value="' . $comment['commentid'] . '" />
	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow2" nowrap="nowrap"><b>Author:</b></td>
	<td class="tdrow3"><input type="text" name="username" value="'.$comment['username'].'" size="20" /></td>
	</tr>
	<tr>
	<td class="tdrow2" nowrap="nowrap"><b>Content:</b></td>
	<td class="tdrow3"><textarea name="content" style="height:160px;width:600px;" id="description">'.$comment['content'].'</textarea></td>
	</tr>	
	<tr>
	<td class="tdrow2" nowrap="nowrap"><b>Online ?</b></td>
	<td class="tdrow3"><input type="checkbox" name="actived" value="1" '.Iif($comment['actived'] == 1, 'CHECKED').'> <b>Yes:</b> Is this comment online or offline?</td>
	</tr>
	<tr>
	<td class="tdrow2" nowrap="nowrap"><b>Delete ?</b></td>
	<td class="tdrow3"><input type="checkbox" name="deletecomment" value="1"> <b>Yes:</b> <span class=ohred>Delete this comment?</span></td>
	</tr>
	<tr>
	<td class="tdrow1" bgcolor="#FCFCFC" colspan="2" align="center">
	<input type="submit" value="Save Comment" />
	</td>
	</tr>
	</table>
	</form>';

	EndSection();
}


// ############################### DISPLAY COMMENTS ###############################

if($action == 'displaycomments')
{
	$NumPerPage =20;

	$page = ForceIncomingInt('page', 1);
	$search = ForceIncomingString('s');
	$actived = ForceIncomingInt('a');

	if(IsGet('s')){
		$search = urldecode($search);
	}

	$start = $NumPerPage * ($page-1);

	PrintSection('Search Comments');
	echo '<form method="post" action="admin.comments.php" name="searchcomments">
	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow2" align="center">Keywords:&nbsp;<input type="text" name="s" size="22">&nbsp;&nbsp;Select:&nbsp;<select name="a">
	<option value="0">All Comments</option>
	<option style="color:red;" value="-1">Offline Comments</option>
	<option value="1">Online Comments</option>
	</select>&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" name="searchcomment" value=" Search " /></td>
	</tr>
	</table></form>';
	EndSection();

	$title = Iif(IsPost('searchcomment'), 'Comments by Searching', 'All Comments');

	$getcomments = $DB->query("SELECT * FROM " . TABLE_PREFIX . "comments ".GetSearchSql($search, $actived)." ORDER BY commentid DESC LIMIT $start,$NumPerPage");

	$maxrows = $DB->query_first("SELECT COUNT(commentid) AS value FROM " . TABLE_PREFIX . "comments ".GetSearchSql($search, $actived));

	PrintSection($title.' ('.$maxrows['value'].')');

	echo '<form method="post" action="admin.comments.php" name="commentsform">
	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1" nowrap="nowrap">Content</td>
	<td class="tdrow1" nowrap="nowrap">Author</td>
	<td class="tdrow1" nowrap="nowrap">Status</td>
	<td class="tdrow1" nowrap="nowrap">Date</td>
	<td class="tdrow1" nowrap="nowrap">Image ID</td>
	<td class="tdrow1" nowrap="nowrap"><input type="checkbox" checkall="group" onclick="select_deselectAll (\'commentsform\', this, \'group\');"> Delete</td>
	</tr>';

	if($maxrows['value'] < 1){
		echo '<tr><td class="tdrow3" colspan="10" align="center" height="48" valign="middle"><font class=ohredb>No any comments found!</font></td></tr>';
	}else{
		while($comment = $DB->getrow($getcomments))
		{
			echo '<tr>
			<td class="tdrow3"><input type="hidden" name="updatecommentids[]" value="'.$comment['commentid'].'" /><a href="admin.comments.php?action=editcomment&commentid=' . $comment['commentid']. '" title="'.$comment['content'].'">'.Iif($comment['actived'] != '1','<font class=ohred><u>').ShortTitle($comment['content'], 48).Iif($comment['actived'] != '1','</u></font>'). '</a></td>
			<td class="tdrow3" nowrap="nowrap">' . $comment['username'] . '</td>
			<td class="tdrow2"><select name="activeds[]">
			<option value="1">Online</option>
			<option style="color:red;" value="0" ' . Iif(!$comment['actived'], 'SELECTED', '') . '>Offline</option>
			</select></td>
			<td class="tdrow2" nowrap="nowrap">' . DisplayDate($comment['created'], 'Y-m-d') . '</td>
			<td class="tdrow2"><a href="'.BASEURL.'InterPhoto.php?id='.$comment['imageid'].'" target="_blank">' . $comment['imageid'] . '</a></td>
			<td class="tdrow3"><input type="checkbox" name="deletecommentids[]" value="' . $comment['commentid'] . '" checkme="group" /></td>
			</tr>';
		}
	}

	$totalpages = ceil($maxrows['value'] / $NumPerPage);

	if($totalpages > 1){
		echo '<tr><td class="tdrow3" colspan="6" align="center" height="48" valign="middle">';
		echo GetPageList('admin.comments.php', $totalpages, $page, 10, 's', urlencode($search), 'a', $actived);
		echo '</td></tr>';
	}

	if($maxrows['value'] > 0){
		echo '<tr><td class="tdrow1" colspan="6" align="center"><input type="submit" name="updatecomments" value="Save Comments" />&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" name="deletecomments" onclick="return confirm(\'Are you sure to delete all the selected comments?\');" value="Delete Comments" /></td></tr>';
	}

	echo '</table></form>';

	EndSection();
}


// ############################### PRINT FOOTER ################################

PrintFooter();

?>