<?php

// +---------------------------------------------+
// |     Copyright  2010 - 2018 InterPhoto       |
// |     http://www.weensoft.com                 |
// |     This file may not be redistributed.     |
// +---------------------------------------------+

include('includes/Admin.Core.php');

CheckAccess('managenews');


PrintHeader('Static Contents');

$action = ForceIncomingString('action', 'displaycontents');
if(IsPost('deletecontents')) $action= 'deletecontents';

// ############################## FUNCTIONS #############################

function GetSearchSql($search) {
	$sWhere = '';
	if($search != ''){
		$sWhere .= " WHERE (username LIKE '%".$search."%' OR keywords LIKE '%".$search."%' OR title LIKE '%".$search."%' OR content LIKE '%".$search."%') ";
	}

	return $sWhere;
}

// ################################ INSERT content ################################

if($action == 'insertcontent' OR $action == 'updatecontent')
{
	$contentid     = ForceIncomingInt('contentid');
	$username        = ForceIncomingString('username', $userinfo['username']);
	$title        = ForceIncomingString('title');
	$content        = ForceIncomingString('content');
	$keywords        = ForceIncomingString('keywords');
	$deletecontent     = ForceIncomingInt('deletecontent');

	if ($deletecontent)
	{
		if($contentid != 1 AND $contentid != 2){
			$DB->query("DELETE FROM " . TABLE_PREFIX . "contents WHERE contentid = '$contentid' ");
		}
		PrintRedirect('admin.contents.php', 1);
	}

	if (strlen($title) == 0)
	{
		$errors[] = "The title of this static content is empty!";
	}

	if(strlen($content) == 0){
		$errors[] = "The content is empty!";
	}

	if ($action == 'insertcontent' AND !isset($errors))
	{
		$DB->query("INSERT INTO " . TABLE_PREFIX . "contents VALUES (NULL, '$username', '$title', '$content', '$keywords', '".time()."')");

		PrintRedirect('admin.contents.php', 1);

	}elseif($action == 'updatecontent' AND !isset($errors)){
		$DB->query("UPDATE " . TABLE_PREFIX . "contents SET 
		username = '$username',
		title     = '$title',
		content     = '$content',
		keywords     = '$keywords'
		WHERE contentid   = '$contentid'");

		PrintRedirect('admin.contents.php', 1);
	}else{
		PrintErrors($errors, Iif($contentid, 'Edit Static Content Errors', 'Add Static Content Errors'));
		$action = 'addcontent';
	}

}


// ############################### DELETE contentS ################################

if($action == 'deletecontents')
{
	$deletecontentids = ForceIncomingArray('deletecontentids');

	for($i = 0; $i < count($deletecontentids); $i++){
		if($deletecontentids[$i] != '1' AND $deletecontentids[$i] != '2'){
			$DB->query("DELETE FROM " . TABLE_PREFIX . "contents WHERE contentid = '$deletecontentids[$i]' ");
		}
	}

	PrintRedirect('admin.contents.php', 1);
}

// ############################ DISPLAY content FORUM #############################

if($action == 'addcontent' OR $action == 'editcontent')
{
	$contentid = ForceIncomingInt('contentid');

	if(isset($errors))
	{
		// content content or edit content with errors, redisplaying the form
		$content = array('contentid'   => $contentid,
			  'username'     => $username,
			  'title'     => $title,
			  'content'     => $_POST['content'],
			  'keywords'     => $keywords);

	} elseif($contentid) {
		$content = $DB->query_first("SELECT * FROM " . TABLE_PREFIX . "contents WHERE contentid = '$contentid'");
	}else{
		$content = array('contentid' => 0, 'username' => $userinfo['username']);
	}

	if($contentid)
	{
		PrintSection('Edit Static Content: ' . ShortTitle($content['title'], 36));
	}else{
		PrintSection('Add Static Content');
	}

	echo '<script src="'.BASEURL.'library/editor/nicEdit.js" type="text/javascript"></script>
	<script type="text/javascript">
	bkLib.onDomLoaded(function() {
		new nicEditor({fullPanel:true, iconsPath: \''.BASEURL.'library/editor/nicEditorIcons.gif\', maxHeight:400}).panelInstance("content");
	});
	</script>';

	echo '<form method="post" action="admin.contents.php">
	<input type="hidden" name="action" value="' . Iif($contentid, 'updatecontent', 'insertcontent') . '" />
	<input type="hidden" name="contentid" value="' . $content['contentid'] . '" />
	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow2" nowrap="nowrap"><b>Author:</b></td>
	<td class="tdrow3"><input type="text" name="username" value="'.$content['username'].'" size="16" /></td>
	</tr>
	<tr>
	<td class="tdrow2" nowrap="nowrap"><b>Title:</b></td>
	<td class="tdrow3"><input type="text" name="title" value="'.$content['title'].'" size="40" /></td>
	</tr>
	<tr>
	<td class="tdrow2" nowrap="nowrap"><b>Content:</b></td>
	<td class="tdrow3" style="background: #fff;"><textarea name="content" style="height:390px;width:600px;" id="content">'.$content['content'].'</textarea></td>
	</tr>	
	<tr>
	<td class="tdrow2" nowrap="nowrap"><b>Meta Keywords:</b></td>
	<td class="tdrow3"><input type="text" name="keywords" value="'.$content['keywords'].'" size="60" /></td>
	</tr>';

	if($contentid)
	{
		echo '<tr>
		<td class="tdrow2" nowrap="nowrap"><b>Delete ?</b></td>
		<td class="tdrow3"><input type="checkbox" name="deletecontent" value="1"> <b>Yes:</b> <span class=ohred>Delete this static content?</span></td>
		</tr>';
	}

	echo '<tr>
	<td class="tdrow1" bgcolor="#FCFCFC" colspan="2" align="center">
	<input type="submit" value="' . Iif($contentid, 'Save Content', 'Add Content') . '" />
	</td>
	</tr>
	</table>
	</form>';

	EndSection();
}


// ############################### DISPLAY contentS ###############################

if($action == 'displaycontents')
{
	$NumPerPage =20;

	$page = ForceIncomingInt('page', 1);
	$search = ForceIncomingString('s');

	if(IsGet('s')){
		$search = urldecode($search);
	}

	$start = $NumPerPage * ($page-1);

	PrintSection('Instructions');
	echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1" colspan="3">How to call a static content?</td>
	</tr>
	<tr>
	<td class="tdrow3" colspan="3">
	<b>Method 1</b>: You can call a static content as the scripts of about.php and about.tpl;
	<BR><b>Method 2</b>: If you want to call a static content directly on a web page, you can add some Smarty codes as below: 
	<BR><BR>Firstly, assign a variable as "mycontent" (ID must be replaced by a static content\'s ID):<BR><font class=weensoft>{assign var="mycontent" value=\'ID\'|GetContent}</font>
	<BR><BR>Call the title of this static content:&nbsp;&nbsp;&nbsp;&nbsp;<font class=weensoft>{$mycontent.title}</font>
	<BR>Call the content of this static content:&nbsp;&nbsp;&nbsp;&nbsp;<font class=weensoft>{$mycontent.content|html}</font>
	<BR>Call the author of this static content:&nbsp;&nbsp;&nbsp;&nbsp;<font class=weensoft>{$mycontent.username}</font>
	<BR>Call the date of this static content:&nbsp;&nbsp;&nbsp;&nbsp;<font class=weensoft>{$mycontent.created|DisplayDate:\'Y-m-d\'}</font>
	</td>
	</tr>
	</table>';
	EndSection();

	PrintSection('Search Static Content');
	echo '<form method="post" action="admin.contents.php" name="searchcontents">
	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow2" align="center">Keywords:&nbsp;<input type="text" name="s" size="22">&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" name="searchcontent" value=" Search " /></td>
	</tr>
	</table></form>';
	EndSection();

	$title = Iif(IsPost('searchcontent'), 'Static Contents by Searching', 'All Static Contents');

	$getcontents = $DB->query("SELECT contentid, username, title, created FROM " . TABLE_PREFIX . "contents ".GetSearchSql($search)." ORDER BY contentid DESC LIMIT $start,$NumPerPage");

	$maxrows = $DB->query_first("SELECT COUNT(contentid) AS value FROM " . TABLE_PREFIX . "contents ".GetSearchSql($search));

	echo '&nbsp;&nbsp;&nbsp;&nbsp;<a href="admin.contents.php?action=addcontent"><img src="'.TEMPLATEPATH.'images/open.gif" align="absmiddle"> <font class=ohblueb><u>Add Static Content</u></font></a>';

	PrintSection($title.' ('.$maxrows['value'].')');

	echo '<form method="post" action="admin.contents.php" name="contentsform">
	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1" nowrap="nowrap">ID</td>
	<td class="tdrow1" nowrap="nowrap">Title</td>
	<td class="tdrow1" nowrap="nowrap">Author</td>
	<td class="tdrow1" nowrap="nowrap">Date</td>
	<td class="tdrow1" nowrap="nowrap"><input type="checkbox" checkall="group" onclick="select_deselectAll (\'contentsform\', this, \'group\');"> Delete</td>
	</tr>';

	if($maxrows['value'] < 1){
		echo '<tr><td class="tdrow3" colspan="10" align="center" height="48" valign="middle"><font class=ohredb>No any static contents found!</font></td></tr>';
	}else{
		while($content = $DB->getrow($getcontents))
		{
			echo '<tr>
			<td class="tdrow2">'.$content['contentid'].'</td>
			<td class="tdrow3"><a href="admin.contents.php?action=editcontent&contentid='.$content['contentid'].'"  title="'.$content['title'].'">'.ShortTitle($content['title'], 48).'</a></td>
			<td class="tdrow2">' . $content['username'] . '</td>
			<td class="tdrow3" nowrap="nowrap">' . DisplayDate($content['created'], 'Y-m-d') . '</td>
			<td class="tdrow2"><input type="checkbox" name="deletecontentids[]" value="' . $content['contentid'] . '" checkme="group" /></td>
			</tr>';
		}
	}

	$totalpages = ceil($maxrows['value'] / $NumPerPage);

	if($totalpages > 1){
		echo '<tr><td class="tdrow3" colspan="7" align="center" height="48" valign="middle">';
		echo GetPageList('admin.contents.php', $totalpages, $page, 10, 's', urlencode($search));
		echo '</td></tr>';
	}

	if($maxrows['value'] > 0){
		echo '<tr><td class="tdrow1" colspan="7" align="center"><input type="submit" name="deletecontents" onclick="return confirm(\'Are you sure to delete all the selected contents?\');" value="Delete Static Contents" /></td></tr>';
	}

	echo '</table></form>';

	EndSection();
}


// ############################### PRINT FOOTER ################################

PrintFooter();

?>