<?php

// +---------------------------------------------+
// |     Copyright  2010 - 2018 InterPhoto       |
// |     http://www.weensoft.com                 |
// |     This file may not be redistributed.     |
// +---------------------------------------------+

include('includes/Admin.Core.php');

CheckAccess('manageimage');


PrintHeader('Add Batch Images');

$action = ForceIncomingString('action', 'displaydefault');

$uploaddir = BASEPATH.'MyWebsiteImages/';
$ImageFromPath = BASEPATH . 'UploadImages/';

@set_time_limit(0);

// ############################## FUNCTIONS #############################

function CreateDirectory($path) {
	if (!file_exists($path)) {
		mkdir($path, 0777);
	}
}

function CreateImageFile($src_path, $des_path, $new_dims) {
	$source = @imagecreatefromjpeg($src_path);

	if ($source) {
		$imageX = @imagesx($source);
		$imageY = @imagesy($source);
		
		if ($imageX >= $imageY) {
			if($imageX >= $new_dims){
				$thumbX = $new_dims;
				$thumbY = (int)(($thumbX*$imageY) / $imageX );
			}else{
				$thumbX = $imageX;
				$thumbY = $imageY;
			}
		} else {
			if($imageY >= $new_dims){
				$thumbY = $new_dims;
				$thumbX = (int)(($thumbY*$imageX) / $imageY );
			}else{
				$thumbX = $imageX;
				$thumbY = $imageY;
			}
		}

		$dest_thum  = @imagecreatetruecolor($thumbX, $thumbY);
		@imagecopyresampled ($dest_thum, $source, 0, 0, 0, 0, $thumbX, $thumbY, $imageX, $imageY);
		@imageinterlace($dest_thum);
		@imagejpeg($dest_thum,$des_path,85);
		@ImageDestroy($dest_thum);
	}
}


function GetAllCategories($parentid, $sublevelmarker = ''){
	global $DB, $allcategories;

	if($parentid != 0){
		$sublevelmarker .= '&nbsp;&nbsp;&nbsp;&nbsp;';
	}

	$getcategories = $DB->query("SELECT categoryid, parentid, title FROM " . TABLE_PREFIX . "categories WHERE parentid = $parentid ORDER BY ordernum");

	while($category = $DB->getrow($getcategories))
	{
		$allcategories[$category['categoryid']] = $sublevelmarker . ShortTitle($category['title'], 18);
		GetAllCategories($category['categoryid'], $sublevelmarker);
	}
}

function GetCategorySelect($selectname, $selectedid = 0){
	global $allcategories;

	$sReturn = '<select name="'.$selectname.'">';

	foreach($allcategories as $key => $value)
	{
		$sReturn .= '<option value="' . $key . '" ' . Iif($selectedid AND $selectedid == $key, ' SELECTED') . '>' . $value . '</option>';
	}

	$sReturn .= '</select>';

	return $sReturn;
	
}


// ################################ IN IMAGES ################################

if($action == 'in')
{
	$categoryid     = ForceIncomingInt('c');
	$usergroup        = ForceIncomingString('ug');
	$usergroupids     = Iif(IsGet('ugs'),urldecode(ForceIncomingString('ugs')), ForceIncomingArray('ugs'));
	$username        = Iif(IsGet('un'),urldecode(ForceIncomingString('un')), ForceIncomingString('un'));
	$watermark     = ForceIncomingInt('w');
	$actived     = ForceIncomingInt('a');
	$number     = ForceIncomingInt('n', 1);

	if(IsPost('ug')){
		if($usergroup == 'all' OR count($usergroupids) < 1){
			$usergroupids = 'all';
		}else{
			$usergroupids = '('.implode(');(', $usergroupids).')';
		}
	}


	if (!$categoryid)
	{
		$errors[] ='Please create a category before adding images!';
	}

	if (!function_exists('imagecreatetruecolor'))
	{
		$errors[] ='Adding images require GD enabled on your server!';
	}

	if (!is_dir($uploaddir)){
		$errors[] ='The directory MyWebsiteImages/ not exist!';
	}else if (!is_writable($uploaddir)){
		$errors[] = 'The directory MyWebsiteImages/ not writable! - CHMOD to 0777';
	}

	if(!isset($errors))	{

		PrintSection('Add Batch Images');
        echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">
		<tr>
		<td class="tdrow3"></br />
		InterPhoto is processing the <font class=ohblueb>' . $number . '</font> file, please waiting......<br /><br />
		</td>
		</tr>
        </table>';
        EndSection();

		echo '<script type="text/javascript">window.location="admin.ftpimages.php?action=do&c='.$categoryid.'&un='.urlencode($username).'&w='.$watermark.'&a='.$actived.'&n='.$number.'&ugs='.urlencode($usergroupids).'"</script>';

	}else{
		PrintErrors($errors, 'Add Batch Images Errors');
		$action = 'displaydefault';
	}

}

// ################################ DO INSERT IMAGES #############################

if($action == 'do')
{
	$categoryid     = ForceIncomingInt('c');
	$usergroupids     = urldecode(ForceIncomingString('ugs'));
	$username        = urldecode(ForceIncomingString('un'));
	$watermark     = ForceIncomingInt('w');
	$actived     = ForceIncomingInt('a');
	$number     = ForceIncomingInt('n');

	$FolderHandle = @opendir($ImageFromPath);

	while (false !== ($Item = readdir($FolderHandle))) {
		if ($imagesize = @getimagesize($ImageFromPath.$Item) AND $imagesize[2] == '2' AND strtolower(substr($Item, -4)) == '.jpg') {

			$file_path_name = DisplayDate(time(), 'Y_m');
			$imagename = md5(uniqid(COOKIE_KEY.mktime())).'.jpg';
			$copysuccess = true;

			$file_path = $file_path_name.'_'.WEBSITE_KEY;

			CreateDirectory($uploaddir.$file_path);
			CreateDirectory($uploaddir.$file_path.'/32x32/');
			CreateDirectory($uploaddir.$file_path.'/80x80/');
			CreateDirectory($uploaddir.$file_path.'/160x160/');
			CreateDirectory($uploaddir.$file_path.'/760x760/');
			CreateDirectory($uploaddir.$file_path.'/original/');

			if ($imagesize[0] > 760 || $imagesize[1] > 760) {
				if (@rename($ImageFromPath.$Item, $uploaddir.$file_path.'/original/'.$imagename)) {
					CreateImageFile($uploaddir.$file_path.'/original/'.$imagename, $uploaddir.$file_path."/760x760/".$imagename,'760');
					CreateImageFile($uploaddir.$file_path.'/760x760/'.$imagename, $uploaddir.$file_path."/160x160/".$imagename,'160');
					CreateImageFile($uploaddir.$file_path.'/160x160/'.$imagename, $uploaddir.$file_path."/80x80/".$imagename,'80');
					CreateImageFile($uploaddir.$file_path.'/80x80/'.$imagename, $uploaddir.$file_path."/32x32/".$imagename,'32');
				}else{
					$copysuccess = false;
				}
			}else{
				if (@rename($ImageFromPath.$Item, $uploaddir.$file_path.'/760x760/'.$imagename)) {
					CreateImageFile($uploaddir.$file_path.'/760x760/'.$imagename, $uploaddir.$file_path."/160x160/".$imagename,'160');
					CreateImageFile($uploaddir.$file_path.'/160x160/'.$imagename, $uploaddir.$file_path."/80x80/".$imagename,'80');
					CreateImageFile($uploaddir.$file_path.'/80x80/'.$imagename, $uploaddir.$file_path."/32x32/".$imagename,'32');
				}else{
					$copysuccess = false;
				}
			}

			if($copysuccess){
				$DB->query("INSERT INTO " . TABLE_PREFIX . "images VALUES (NULL, '$ordernum',  '$categoryid', '$userinfo[userid]', '$username', '$actived', '$watermark', '$sale', 0, '$usergroupids', '$file_path_name', '$imagename', '$price', '".iconv('gbk','utf-8',$Item)."', '$description', '', '$keywords', '$url', '0', '0', '".time()."')");

				$imageid = $DB->insert_id();
				$DB->query("UPDATE " . TABLE_PREFIX . "images SET ordernum = '$imageid' WHERE imageid = '$imageid'");

				$number++;
			}

			PrintRedirect('admin.ftpimages.php?action=in&c='.$categoryid.'&un='.urlencode($username).'&w='.$watermark.'&a='.$actived.'&n='.$number.'&ugs='.urlencode($usergroupids), 0);

			exit();

		}
	}

	@closedir($ImageFromPath);

	PrintSection('Batch Adding Results');
	echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow3"></br />
	Total <font class=ohblueb>' . ($number -1) . '</font> images have been added.<br /><br />
	</td>
	</tr>
	</table>';
	EndSection();

	$action = 'displaydefault';
}


// ############################ DISPLAY IMAGE FORUM #############################

if($action == 'displaydefault')
{
	$allcategories = array();
	GetAllCategories(0);

	@chmod($uploaddir, 0777);

	$ftpEnabled = false;

	if (!is_dir($ImageFromPath)) {
		$errors ='The directory UploadImages/ not exist!';
	}else{
		@chmod($ImageFromPath, 0777);
		if (!is_writable($ImageFromPath))	$errors = 'The directory UploadImages/ not writable! - CHMOD to 0777';
	}

	if (isset($errors)){
		PrintErrors($errors, 'Configuration Error');
	}else{
		$ftpEnabled = true;
	}

	$FolderHandle = @opendir($ImageFromPath);
	$filecount = 0;
	$jpgfilecount = 0;

	while (false !== ($Item = readdir($FolderHandle))) {
		if ($Item != '.' 	&& $Item != '..') {
			$filecount++;

			if ($imagesize = @getimagesize($ImageFromPath.$Item) AND $imagesize[2] == '2' AND strtolower(substr($Item, -4)) == '.jpg') {
				$jpgfilecount++;
			}
		}
	}

	@closedir($ImageFromPath);

	PrintSection('Description');

	echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow2" width="120"><b>Instructions:</b></td>
	<td class="tdrow3">1). Uploading images through FTP tools to the directory <font class=ohblueb>/UploadImages/</font> firstly.<BR>2). Only <font class=ohredb>JPG</font> image files are available.</td>
	</tr>
	<tr>
	<td class="tdrow2" width="120"><b>Status:</b></td>
	<td class="tdrow3">There are total <b>'.$filecount.'</b> files in UploadImages/ directory currently, and total <font class=ohblueb>'.$jpgfilecount.'</font> JPG files are available.</td>
	</tr>
	</table>';

	EndSection();

	$getusergroups = $DB->query("SELECT groupid, name FROM " . TABLE_PREFIX . "usergroups ORDER BY groupid");
	while($usergroup = $DB->getrow($getusergroups)) {
		$usergroups[$usergroup['groupid']] = $usergroup['name'];
	}


	PrintSection('Add Batch Images');

	echo '<form method="post" action="admin.ftpimages.php">
	<input type="hidden" name="action" value="in" />
	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow2" width="120"><b>Category:</b></td>
	<td class="tdrow3">'.GetCategorySelect('c').'</td>
	</tr>
	<tr>
	<td class="tdrow2" width="120"><b>Usergroups:</b></td>
	<td class="tdrow3"><input type="radio" name="ug" value="all" checked="checked" onclick="HideDIV(\'div_usergroupids\');">All Usergroups&nbsp;&nbsp;&nbsp;<input type="radio" name="ug" value="none" onclick="ShowDIV(\'div_usergroupids\');">Select (This setting means: which usergroups can see this image)<BR><div id="div_usergroupids" style="border: 1px solid #996600;background-color:#fffeec;margin:6px;padding:6px; display: none;">';

	foreach($usergroups as $key => $value)
	{
		echo '<input  type="checkbox" name="ugs[]" value="' . $key . '">' . $value . '&nbsp;&nbsp;&nbsp;&nbsp;';
	}

	echo '</div>
	</td>
	</tr>
	<tr>
	<td class="tdrow2" width="120"><b>Author:</b></td>
	<td class="tdrow3"><input type="text" name="un" value="'.$userinfo['username'].'" size="16" /></td>
	</tr>
	<tr>
	<td class="tdrow2" width="120"><b>Watemarking ?</b></td>
	<td class="tdrow3"><input type="checkbox" name="w" value="1" CHECKED> <b>Yes:</b> Add a watermark on their big images while showing?</td>
	</tr>
	<tr>
	<td class="tdrow2" width="120"><b>Online ?</b></td>
	<td class="tdrow3"><input type="checkbox" name="a" value="1" CHECKED> <b>Yes:</b> Are these images online or offline?</td>
	</tr>
	<tr>
	<td class="tdrow1" bgcolor="#FCFCFC" colspan="2" align="center">
	<input type="submit" value="Add Batch" ' . Iif($ftpEnabled, '', 'disabled') . ' />
	</td>
	</tr>
	</table>
	</form>';

	EndSection();
}

// ############################### PRINT FOOTER ################################

PrintFooter();

?>