<?php

// +---------------------------------------------+
// |     Copyright  2010 - 2018 InterPhoto       |
// |     http://www.weensoft.com                 |
// |     This file may not be redistributed.     |
// +---------------------------------------------+

include('includes/Admin.Core.php');

CheckAccess('managecategory');


PrintHeader('Categories');

$action = ForceIncomingString('action', 'displaydefault');

@set_time_limit(600);

// ############################## FUNCTION #############################

function DisplayCategorySelection($categoryid, $selectedid =0, $showzerovalue = 1, $parentid = 0, $begin = 1, $sublevelmarker = '', $selectname = 'parentid')
{
	global $DB;

	if($begin){
		echo '<select name="' . $selectname . '">';

		if($showzerovalue)
		{
			echo '<option value="0">None</option>';
		}
	}else{
		$sublevelmarker .= '&nbsp;&nbsp;&nbsp;&nbsp;';
	}

	$getcategories = $DB->query("SELECT categoryid, title FROM " . TABLE_PREFIX . "categories WHERE parentid = $parentid ORDER BY ordernum");

	while($category = $DB->getrow($getcategories))
	{
		if($categoryid != $category['categoryid']){
			echo '<option value="' . $category['categoryid'] . '" ' . Iif($selectedid == $category['categoryid'], 'SELECTED', '') . '>' . $sublevelmarker . ShortTitle($category['title'], 18) . '</option>';

			DisplayCategorySelection($categoryid, $selectedid, 0, $category['categoryid'], 0, $sublevelmarker);
		}

	}

	if($begin){
		echo '</select>';
	}
}


// ########################### UPDATE CATEGORIES ############################

if($action == 'updatecategories'){
	$categoryids   = ForceIncomingArray('categoryids');
	$ordernums   = ForceIncomingArray('ordernums');
	$activeds   = ForceIncomingArray('activeds');
	$titles   = ForceIncomingArray('titles');
	$sortings   = ForceIncomingArray('sortings');

	$categorycount = count($categoryids);


    for($i = 0; $i < $categorycount; $i++)
    {
		$DB->query("UPDATE " . TABLE_PREFIX . "categories SET ordernum = '". ForceInt($ordernums[$i])."',
		actived = '$activeds[$i]',
		title = '". ForceString($titles[$i])."',
		sorting = '$sortings[$i]'
		WHERE categoryid = '$categoryids[$i]'");
    }

    PrintRedirect('admin.icategories.php', 1);

}


// ############################## DELETE category #############################

if($action == 'deletecategory')
{
	$categoryid = ForceIncomingInt('categoryid');
	$parentid = ForceIncomingInt('parentid');

	if($subcategory = $DB->query_first("SELECT categoryid FROM " . TABLE_PREFIX . "categories WHERE parentid = '$categoryid'")){
		$errors = "This category has a sub category! please delete the sub category firstly.";
		PrintErrors($errors, 'Delete Category Error');
		$action = 'displaydefault';
	}else{

		if(IsPost('confirmcancel'))
		{
			$action = 'displaydefault';

		}else if(IsPost('confirmdelete'))	{

			$DB->query("DELETE FROM " . TABLE_PREFIX . "categories WHERE categoryid = '$categoryid' ");

			if($parentid != 0){

				$DB->query("UPDATE " . TABLE_PREFIX . "images SET categoryid = '$parentid' WHERE categoryid = '$categoryid' ");

			}else{

				$getimages = $DB->query("SELECT imageid FROM " . TABLE_PREFIX . "images WHERE categoryid = '$categoryid' ");

				while($image = $DB->getrow($getimages)){
					DeleteImageById ($image['imageid']);
				}

			}

			PrintRedirect('admin.icategories.php', 1);

		}else{

			$category = $DB->query_first("SELECT parentid, title  FROM " . TABLE_PREFIX . "categories WHERE categoryid = '$categoryid'");

			PrintSection('Delete Category');

			echo '<form method="post" action="admin.icategories.php">
			<input type="hidden" name="categoryid" value="' . $categoryid . '" />
			<table width="100%" border="0" cellpadding="5" cellspacing="0">
			<tr><td class="tdrow1" colspan="2">Confirm Delete</td></tr>
			<tr>
			<td class="tdrow2" width="60%" valign="top"><b>Are sure to delete this category: "<font class=ohredb>' . $category['title'] . '</font>" ?</b><br /><br />';

			if($othercategory = $DB->query_first("SELECT categoryid FROM " . TABLE_PREFIX . "categories WHERE  categoryid != '$categoryid' AND parentid = 0 ")){
				echo 'All images of this category will be moved into: ';
				DisplayCategorySelection($categoryid, $category['parentid'], 0);
			}else{
				echo 'Warning: <font class=ohredb>all images of this category will be deleted!</font>';
			}

			echo '</td>
			<td class="tdrow3" valign="top">
			
			<input type="hidden" name="action" value="deletecategory" />
			<input type="submit" name="confirmdelete" value=" Delete " />&nbsp;&nbsp;
			<input type="submit" name="confirmcancel" value=" Cancel " />
			
			</td>
			</tr>
			</table></form>';
			EndSection();

		}

	}
}



// ############################# INSERT OR EDIT category ###########################

if($action == 'insertcategory' OR $action == 'updatecategory')
{
	$categoryid = ForceIncomingInt('categoryid');
	$parentid = ForceIncomingInt('parentid');
	$ordernum = ForceIncomingInt('ordernum');
	$actived = ForceIncomingInt('actived');
	$title  = ForceIncomingString('title');
	$description  = ForceIncomingString('description');
	$keywords  = ForceIncomingString('keywords');
	$datasize = ForceIncomingInt('datasize');
	$sorting  = ForceIncomingString('sorting');
	$watermark = ForceIncomingInt('watermark');
	$watermarkpos = ForceIncomingInt('watermarkpos');

	if ($title == '')
	{
		$errors = "Please enter a category name!";
	}

	if($errors){

		if($action == 'insertcategory'){
			PrintErrors($errors, 'Create Category Error');
			$action = 'createcategory';
		}else if($action == 'updatecategory'){
			PrintErrors($errors, 'Edit Category Error');
			$action = 'editcategory';
		}

	}else{
		if($action == 'insertcategory'){
			$DB->query("INSERT INTO " . TABLE_PREFIX . "categories VALUES (NULL, '$parentid', '$ordernum', '$actived', '$title', '$description', '$keywords', '$datasize', '$sorting', '$watermark', '$watermarkpos') ");

			$categoryid = $DB->insert_id();
			$DB->query("UPDATE " . TABLE_PREFIX . "categories SET ordernum     = '$categoryid' WHERE categoryid = '$categoryid'");

		}else if($action == 'updatecategory'){
			$DB->query("UPDATE " . TABLE_PREFIX . "categories SET 
			parentid= '$parentid',
			ordernum     = '$ordernum',
			actived     = '$actived',
			title     = '$title',
			description     = '$description',
			keywords     = '$keywords',
			datasize     = '$datasize',
			sorting     = '$sorting',
			watermark     = '$watermark',
			watermarkpos     = '$watermarkpos'
			WHERE categoryid   = '$categoryid'");
		}

		PrintRedirect('admin.icategories.php', 1);
	}

}

// ############################## DISPLAY DEFAULT ##############################

if($action == 'displaydefault')
{
	$NumPerPage =20;
	$page = ForceIncomingInt('page', 1);
	$start = $NumPerPage * ($page-1);

	$getcategories = $DB->query("SELECT categoryid, parentid, ordernum, actived, title, sorting, watermark, watermarkpos  FROM " . TABLE_PREFIX . "categories ORDER BY parentid, ordernum LIMIT $start,$NumPerPage");
	$maxrows = $DB->query_first("SELECT COUNT(categoryid) AS value FROM " . TABLE_PREFIX . "categories");


	$getcategorytitles = $DB->query("SELECT categoryid, title FROM " . TABLE_PREFIX . "categories");

	while($category = $DB->getrow($getcategorytitles)) {
		$categorytitles[$category['categoryid']] = $category['title'];
	}

	PrintSection('Create Category');
	echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow2" width="60%">Create a new category:</td>
	<td class="tdrow3">
	<form method="post" action="admin.icategories.php">
	<input type="hidden" name="action" value="createcategory" />
	<input type="submit" value="Create Category" />
	</form>
	</td>
	</tr>
	</table>';
	EndSection();

	PrintSection('Current Categories ('.$maxrows['value'].')');

	echo '<form method="post" action="admin.icategories.php">
	<input type="hidden" name="action" value="updatecategories" />
	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1" nowrap="nowrap">No.</td>
	<td class="tdrow1" nowrap="nowrap">Name</td>
	<td class="tdrow1" nowrap="nowrap">Parent</td>
	<td class="tdrow1" nowrap="nowrap">Images</td>
	<td class="tdrow1" nowrap="nowrap">Status</td>
	<td class="tdrow1" nowrap="nowrap">Rename</td>
	<td class="tdrow1" nowrap="nowrap">Images Sort</td>
	<td class="tdrow1" nowrap="nowrap">Edit</td>
	<td class="tdrow1" nowrap="nowrap">Delete</td>
	</tr>';

	if($maxrows['value'] < 1){
		echo '<tr><td class="tdrow3" colspan="9" align="center" height="48" valign="middle"><font class=ohredb>No any categories yet!</font></td></tr>';
	}else{
		while($category = $DB->getrow($getcategories))
		{

			$totalimages = $DB->query_first("SELECT COUNT(imageid) AS value FROM " . TABLE_PREFIX . "images WHERE categoryid = '" . $category['categoryid'] . "'");

			echo '<tr>
			<td class="tdrow2"><input type="hidden" name="categoryids[]" value="' . $category['categoryid'] . '" /><input type="text" name="ordernums[]" value="' . $category['ordernum'] . '"  size="3" /></td>
			<td class="tdrow3"><a href="admin.icategories.php?action=editcategory&categoryid=' . $category['categoryid'] . '" title="'.$category['title'].'">' . ShortTitle($category['title'], 18) . '</a></td>
			<td class="tdrow3">' . Iif($category['parentid'], $categorytitles[$category['parentid']], '&nbsp;') . '</td>
			<td class="tdrow3">' . $totalimages['value'] . '</td>
			<td class="tdrow3"><select name="activeds[]">
			<option value="1">Online</option>
			<option style="color:red;" value="0" ' . Iif(!$category['actived'], 'SELECTED', '') . '>Offline</option>
			</select></td>
			<td class="tdrow3"><input type="text" name="titles[]" value="' . $category['title'] . '" size="12" /></td>
			<td class="tdrow3"><select name="sortings[]">
			<option value="odown"  '.Iif($category['sorting'] == 'odown', 'selected') .'>Image No. DESC</option>
			<option value="oup"  '.Iif($category['sorting'] == 'oup', 'selected') .'>Image No. ASC</option>
			<option value="tdown"  '.Iif($category['sorting'] == 'tdown', 'selected') .'>Newest First</option>
			<option value="tup"  '.Iif($category['sorting'] == 'tup', 'selected') .'>Oldest First</option>
			</select></td>
			<td class="tdrow3"><a href="admin.icategories.php?action=editcategory&categoryid=' . $category['categoryid'] . '"><img src="' . TEMPLATEPATH . 'images/configure.gif" /></a></td>
			<td class="tdrow2"><a href="admin.icategories.php?action=deletecategory&categoryid=' . $category['categoryid'] . '"><img src="' . TEMPLATEPATH . 'images/trash.gif" /></a></td>
			</tr>';
		}
	}

	$totalpages = ceil($maxrows['value'] / $NumPerPage);

	if($totalpages > 1){
		echo '<tr><td class="tdrow3" colspan="9" align="center" height="48" valign="middle">';
		echo GetPageList('admin.icategories.php', $totalpages, $page, 10);
		echo '</td></tr>';
	}

	echo '<tr><td class="tdrow1" colspan="9" align="center"><input type="submit" value="Save Categories" /></td></tr></table></form>';

	EndSection();
}


// ########################## DISPLAY category FORM ###########################

if($action == 'createcategory' OR $action == 'editcategory')
{
	if(isset($errors))
	{
		$category = array('categoryid'   => $categoryid,
		'parentid'   => $parentid,
		'ordernum'     => $ordernum,
		'actived'     => $actived,
		'title'     => $title,
		'description'     => $_POST['description'],
		'keywords'     => $keywords,
		'datasize'     => $datasize,
		'sorting'     => $sorting,
		'watermark'     => $watermark,
		'watermarkpos'     => $watermarkpos);

	}else if($action == 'editcategory'){
		$categoryid = ForceIncomingInt('categoryid');
		$category = $DB->query_first("SELECT * FROM " . TABLE_PREFIX . "categories WHERE categoryid = '$categoryid'");
	}else{
		$category = array();
		$category['categoryid'] = 0;
		$category['parentid'] = 0;
		$category['datasize'] = 2048;
		$category['watermark'] = 1;
		$category['watermarkpos'] = 0;
		$category['actived'] = 1;
		$category['sorting'] = 'orderdown';
	}

	if($categoryid)
	{
		PrintSection('Edit Category: ' . $category['title']);
	}else{
		PrintSection('Create Category');
	}

	echo '<script src="'.BASEURL.'library/editor/nicEdit.js" type="text/javascript"></script>
	<script type="text/javascript">
	bkLib.onDomLoaded(function() {
		new nicEditor({fullPanel:true, iconsPath: \''.BASEURL.'library/editor/nicEditorIcons.gif\', maxHeight:120}).panelInstance("description");
	});
	</script>';

	echo '<form method="post" action="admin.icategories.php" name="categories">
	<input type="hidden" name="action" value="' . Iif($action == 'createcategory', 'insertcategory', 'updatecategory') . '" />
	<input type="hidden" name="categoryid" value="' . $category['categoryid'] . '" />

	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1" colspan="2">Category Name</td>
	</tr>
	<tr>
	<td class="tdrow2">Enter a name for this category(<font class=ohred>Required</font>):</td>
	<td class="tdrow3"><input type="text" name="title" value="' . $category['title'] . '"  size="30" /></td>
	</tr>
	<tr>
	<td class="tdrow1" colspan="2">Parent Category</td>
	</tr>
	<tr>
	<td class="tdrow2">Select a parent category for this category:</td>
	<td class="tdrow3">';
	DisplayCategorySelection($category['categoryid'], $category['parentid']);
	echo '</td>
	</tr>	';

	if($categoryid)
	{
		echo '<tr>
		<td class="tdrow1" colspan="2">Category No.</td>
		</tr>
		<tr>
		<td class="tdrow2">This number is used for sorting categories:</td>
		<td class="tdrow3"><input type="text" name="ordernum" value="' . $category['ordernum'] . '"  size="16" /></td>
		</tr>	';
	}

	echo '<tr>
	<td class="tdrow1" colspan="2">Sort Images By</td>
	</tr>
	<tr>
	<td class="tdrow2">Select a sort type of images in this category:</td>
	<td class="tdrow3">
	<select name="sorting">
	<option value="odown"  '.Iif($category['sorting'] == 'odown', 'selected') .'>Image No. DESC</option>
	<option value="oup"  '.Iif($category['sorting'] == 'oup', 'selected') .'>Image No. ASC</option>
	<option value="tdown"  '.Iif($category['sorting'] == 'tdown', 'selected') .'>Newest First</option>
	<option value="tup"  '.Iif($category['sorting'] == 'tup', 'selected') .'>Oldest First</option>
	</select>
	</td>
	</tr>
	<tr>
	<td class="tdrow1" colspan="2">Filesize Limit(Kb)</td>
	</tr>
	<tr>
	<td class="tdrow2">The max filesize of an image allowed to upload in this category(Kb):</td>
	<td class="tdrow3"><input type="text" name="datasize" value="' . $category['datasize'] . '"  size="16" />&nbsp;(Re: 1024kb = 1M)</td>
	</tr>
	<tr>
	<td class="tdrow1" colspan="2">Watermarking ?</td>
	</tr>
	<tr>
	<td class="tdrow2">Add a watermark on it while a big image belong to this category is showing?</td>
	<td class="tdrow3"><input type="checkbox" name="watermark" value="1" '.Iif($category['watermark'] == 1, 'CHECKED').'></td>
	</tr>
	<tr>
	<td class="tdrow1" colspan="2">Watermark Position</td>
	</tr>
	<tr>
	<td class="tdrow2">The position of watermark added:</td>
	<td class="tdrow3">
	<select name="watermarkpos">
	<option value="0"  '.Iif($category['watermarkpos'] == '0', 'selected') .'>Center</option>
	<option value="1"  '.Iif($category['watermarkpos'] == '1', 'selected') .'>Top-Left</option>
	<option value="2"  '.Iif($category['watermarkpos'] == '2', 'selected') .'>Top-Right</option>
	<option value="3"  '.Iif($category['watermarkpos'] == '3', 'selected') .'>Bottom-Left</option>
	<option value="4"  '.Iif($category['watermarkpos'] == '4', 'selected') .'>Bottom-Right</option>
	</select>
	</td>
	</tr>
	<tr>
	<td class="tdrow1" colspan="2">Online ?</td>
	</tr>
	<tr>
	<td class="tdrow2">Is all the images of this category online?</td>
	<td class="tdrow3"><input type="checkbox" name="actived" value="1" '.Iif($category['actived'] == 1, 'CHECKED').'></td>
	</tr>
	<tr>
	<td class="tdrow1" colspan="2">Meta Keywords</td>
	</tr>
	<tr>
	<td class="tdrow2">Meta Keywords help this category be listed in search engines:</td>
	<td class="tdrow3"><input type="text" name="keywords" value="' . $category['keywords'] . '"  size="30" /></td>
	</tr>
	<tr>
	<td class="tdrow1" colspan="2">Short Description</td>
	</tr>
	<tr>
	<td class="tdrow2">A short description for this category:</td>
	<td class="tdrow3" style="background: #fff;"><textarea name="description" cols="62" style="height:110px" id="description">'.$category['description'].'</textarea></td>
	</tr>	';

	echo '<tr><td class="tdrow1" colspan="2" align="center"><input type="submit" name="" value="' . Iif($action == 'createcategory', 'Create Category', 'Save Category') . '" /></td></tr></table></form>';
  
	EndSection();

}

// ############################### PRINT FOOTER ################################

PrintFooter();

?>