<?php

// +---------------------------------------------+
// |     Copyright  2010 - 2018 InterPhoto       |
// |     http://www.weensoft.com                 |
// |     This file may not be redistributed.     |
// +---------------------------------------------+

include('includes/Admin.Core.php');

CheckAccess('managelanguage');

PrintHeader('Languages');

$action = ForceIncomingString('action', 'displaylanguages');
$folderpath = BASEPATH.'languages/';

// ############################# GET LANGUAGE DETAILS#############################

function DisplayFileDetails($file, $tdstyle = '')
{
	global $folderpath;

	$filepath = $folderpath . $file;

	echo '<table width="100%" border="0" cellpadding="0" cellspacing="0">
	<tr>
	<td width="10" valign="top" style="padding-right: 15px;">
	<a href="admin.languages.php?action=editfile&filename=' . $file . '"><img border="0" src="'.TEMPLATEPATH.'images/editablefile' . Iif($tdstyle == 'tdrow3', '1' , '2') . '.gif" /></a>
	</td>
	<td valign="top">
	<b>' . $file . '</b> (' .DisplayFilesize(filesize($filepath)). ')<br /><br />
	<a href="admin.languages.php?action=deletefile&filename=' . $file . '">Delete</a><br /><br />
	<a href="admin.languages.php?action=editfile&filename=' . $file . '">Edit</a>
	</td>
	</tr>
	</table>';
}



// ############################### UPLOAD FILE ################################

function UploadFile()
{
	global $folderpath;

	$languagefile     = $_FILES['languagefile'];

	if($languagefile['size'] == 0)
	{
		$errors[] = 'No file is selected!';
	}else if(strtolower(substr($languagefile['name'], -3)) != 'php') {
		$errors[] = 'File type is not allowed!';
	}else if (file_exists($folderpath . $languagefile['name'])) {
		$errors[] = 'A file with same filename exists, you could delete this file then upload another one!';
	}else{
		@chmod($folderpath, 0777);
		if(!@copy($languagefile['tmp_name'], $folderpath . $languagefile['name']))
		{
			$errors[] = 'This directory "' . BASEURL . 'languages/" is not writable!<br />Re: CHMOD "' . BASEURL . 'languages/" to 777';
		}else{
			@chmod($folderpath . $languagefile['name'], 0777);
		}
	}

	if(isset($errors))
	{
		PrintErrors($errors, 'Upload File Errors');
		DisplayLanguages();
	}else{
		DisplayLanguages(true);
	}
}

// ############################### DELETE FILE ################################

function DeleteFile()
{
	global $folderpath;
	$filename = ForceIncomingString('filename');

	if(IsPost('deletefile')){
		if(@unlink($folderpath.$filename))
		{
			PrintRedirect('admin.languages.php', 1);
		}else{
			$errors[] = 'Deleting language file failed!';
			PrintErrors($errors, 'Delete Failed');
		}
	}else if(IsPost('cancel')){
		PrintRedirect('admin.languages.php');
	}


	PrintSection('Delete File');
	echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">
		<tr><td class="tdrow1" colspan="2">Confirm Delete</td></tr>
		<tr>
		<td class="tdrow2" width="70%" valign="top">File: <b>' . $filename . '</b> (' .DisplayFilesize(filesize($folderpath.$filename)) . ')<br /><br />Are sure to delete this language file?</td>
		<td class="tdrow3" valign="top">
		<form method="post" action="admin.languages.php">
		<input type="hidden" name="action" value="deletefile" />
		<input type="hidden" name="filename" value="' . $filename . '" />
		<input type="submit" name="deletefile" value=" Delete " />&nbsp;&nbsp;
		<input type="submit" name="cancel" value=" Cancel " />
		</form>
		</td>
		</tr>
		</table>';
	EndSection();
}


// ############################### EDIT FILE ################################

function EditFile()
{
	global $folderpath;

	$filename = ForceIncomingString('filename');

	if(IsPost('savefile')){

		if (is_writable($folderpath.$filename)) {
			$filecontent = trim($_POST['filecontent']);
			if (get_magic_quotes_gpc()) {
				$filecontent = stripslashes($filecontent);
			}

			$fd = fopen($folderpath.$filename, 'wb');
			fputs($fd,$filecontent);
			PrintRedirect('admin.languages.php', 1);
		}else{
			$errors = 'Language file ('.$filename.') is not writable! Please CHMOD it to 777';
			PrintErrors($errors, 'Edit Languge File Error');
		}

	}else if(IsPost('cancel')){
		PrintRedirect('admin.languages.php');
	}

	if ($filename){ $oldfilecontent = implode("",file($folderpath . $filename));}

	PrintSection('Edit Language File');
	echo '<form method="post" action="admin.languages.php">
	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1">
	<input type="hidden" name="action" value="editfile" />
	<input type="hidden" name="filename" value="' . $filename . '" />
	<input type="submit" name="savefile" value=" Save " onclick="return confirm(\'Are sure to save this language file?\');" />&nbsp;&nbsp;
	<input type="submit" name="cancel" value=" Cancel " /></td>
	</tr>
	<tr>
	<td class="tdrow2" width="100%" valign="top">File: ' . BASEURL . 'languages/'.$filename.'<BR><BR>
	<textarea rows="36" style="width:100%;" name="filecontent" >' . $oldfilecontent . '</textarea>
	</td>
	</tr>
	<tr>
	<td class="tdrow1">
	<input type="submit" name="savefile" value=" Save " onclick="return confirm(\'Are sure to save this language file?\');" />&nbsp;&nbsp;
	<input type="submit" name="cancel" value=" Cancel " /></td>
	</tr>
	</table></form>';

	EndSection();

}


// ############################### DISPLAY LANGUAGES ##############################

function DisplayLanguages($uploaded = '')
{
	global $folderpath;

	PrintSection('Upload Language Files');
	echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">
		<tr>
		<td class="tdrow1"><b>Directory:</b> ' . BASEURL . 'languages/</td>
		</tr>
		<tr>
		<td class="tdrow2">';
	  
	if($uploaded){
		echo '<font class=ohblueb>File uploaded successfully!</font><br /><br />';
	}

	echo 'Upload file to this directory:<br />
		<form enctype="multipart/form-data" method="post" action="admin.languages.php" name="upload_form">
		<input type="hidden" name="action" value="uploadfile" />
		<input name="languagefile" type="file" size="38" />
		<input type="submit" value="Upload" />
		</form><br />(Re: only php file is allowed. You could copy a language file, translate or modify it, then rename and upload it)</td>
		</tr>
		</table>';

	EndSection();

	PrintSection('Lists of Language Files');

	$files   = GetLangs(1);
	$columncount = 0;
	$tdstyle = 'tdrow3';
	echo '<table width="100%" border="0" cellpadding="5" cellspacing="0"><tr>
		<td class="tdrow1" colspan="3"><b>Directory:</b> ' . BASEURL . 'languages/</td>
		</tr>';

	for($i = 0; $i < count($files); $i++) {
		$columncount++;

		if($columncount == 1)	{
			echo '<tr>';
			$tdstyle = ($tdstyle == 'tdrow3') ? 'tdrow2' : 'tdrow3';
		}

		echo '<td width="33%" class="' . $tdstyle . '">';
		DisplayFileDetails($files[$i], $tdstyle);
		echo '</td>';

		if($columncount == 3)
		{
			echo '</tr>';
			$columncount = 0;
		}
	}

	@closedir($handle);

	if($columncount != 0 && $columncount != 3)
	{
		while($columncount < 3)
		{
			$columncount++;
			echo '<td class="' . $tdstyle . '">&nbsp;</td>';
		}
		echo '</tr>';
	}

	echo '</table>';

	EndSection();
}



// ############################## SELECT FUNCTION ##############################


switch($action)
{
  case 'uploadfile':
    UploadFile();
  break;

  case 'deletefile':
    DeleteFile();
  break;
  
  case 'editfile':
    EditFile();
  break;

  case 'displaylanguages':
    DisplayLanguages();
  break;
}


PrintFooter();

?>