<?php

// +---------------------------------------------+
// |     Copyright  2010 - 2018 InterPhoto       |
// |     http://www.weensoft.com                 |
// |     This file may not be redistributed.     |
// +---------------------------------------------+

include('includes/Admin.Core.php');

CheckAccess('managesetting');


PrintHeader('Settings');

// get the value of $action
$action = ForceIncomingString('action', 'displaysettings');


// ############################## UPDATE SETTINGS ##############################

if($action == 'updatesettings')
{
	$settings    = ForceIncomingArray('settings');

    foreach($settings as $key => $value)
	{
		if($mainsettings[$key] != $settings[$key]){
			$DB->query("UPDATE " . TABLE_PREFIX . "mainsettings SET value = '".ForceString($value)."' WHERE varname = '".ForceString($key)."'");
		}
	}

	if($mainsettings['siteDefaultTemplate'] != $settings['siteDefaultTemplate']){
		require_once (BASEPATH . 'library/smarty/libs/Smarty.class.php');
		$smarty = new Smarty;
		$smarty->compile_dir = BASEPATH.'library/smarty/templates_c/';
		$smarty->clear_compiled_tpl();
	}

	PrintRedirect('admin.mainsettings.php', 1);

}



// ############################### PRINT DEFAULT ###############################
if($action == 'displaysettings')
{

  echo '<form method="post" action="admin.mainsettings.php">
        <input type="hidden" name="action" value="updatesettings">';


    PrintSection('Language Options');
    echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1" colspan="2">Front End Default Language</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">Select the default language of site front end.</td>
	<td class="tdrow3" valign="top">';

	$Langs = GetLangs();

	$Select = NewObject('Select');
	$Select->Name = 'settings[siteDefaultLang]';
	$Select->SelectedValue = $mainsettings['siteDefaultLang'];
	foreach($Langs as $val)
	{
		$Select->AddOption($val, $val);
	}

	echo $Select->Get();

	echo '</td></tr>';

    echo '</table>';

    EndSection();

// ##############################################################

    PrintSection('Main Settings');
    echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1" colspan="2">Friendly URL</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">If your sever is running on Apache and Mod-Rewrite enabled, then you can turn this setting on to make your URLs more friendly to search engines.</td>
	<td class="tdrow3" valign="top">';


	$Radio = NewObject('Radio');
	$Radio->Name = 'settings[siteRewrite]';
	$Radio->SelectedID = $mainsettings['siteRewrite'];
	$Radio->AddOption(1, 'On', '&nbsp;&nbsp;');
	$Radio->AddOption(0, 'Off', '&nbsp;&nbsp;');

	echo $Radio->Get();

	echo '</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Allow Guests to Browse Site</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">Whether allow guests(non-members) to visit your site?<BR><BR>If \'<b>No</b>\', all users must sign-in to browse your site.</td>
	<td class="tdrow3" valign="top">';

	$Radio->Clear();
	$Radio->Name = 'settings[siteAllowGuest]';
	$Radio->SelectedID = $mainsettings['siteAllowGuest'];
	$Radio->AddOption(1, 'Yes', '&nbsp;&nbsp;');
	$Radio->AddOption(0, 'No', '&nbsp;&nbsp;');

	echo $Radio->Get();

	echo '</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Open Users Register</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">Whether open register to users?</td>
	<td class="tdrow3" valign="top">';

	$Radio->Clear();
	$Radio->Name = 'settings[siteAllowRegister]';
	$Radio->SelectedID = $mainsettings['siteAllowRegister'];
	$Radio->AddOption(1, 'Yes', '&nbsp;&nbsp;');
	$Radio->AddOption(0, 'No', '&nbsp;&nbsp;');
	$Radio->Attributes = " onclick=\"if(this.value==1){EnableID('siteRegisterCheck');}else{DisableID('siteRegisterCheck');}\"";

	echo $Radio->Get();

	echo '</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Register Verification</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">The register verification mode when register is open. If \'<b>Auto</b>\', the registered users immediately take membership.</td>
	<td class="tdrow3" valign="top">';

	$Select->Clear();
	$Select->Name = 'settings[siteRegisterCheck]';
    $Select->Attributes = " id='siteRegisterCheck'";
	if($mainsettings['siteAllowRegister'] == '0'){
		$Select->Attributes .= " disabled='disabled'";
	}
	$Select->SelectedValue = $mainsettings['siteRegisterCheck'];

	$Select->AddOption('Auto', 'Auto');
	$Select->AddOption('EmailVerify', 'Email');
	$Select->AddOption('AdminVerify', 'Manual');

	echo $Select->Get();

	echo '</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Site Default Template</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">Select default template for your site. Templates locate in ./templates/ directory.</td>
	<td class="tdrow3" valign="top">';

	$Templates = GetTemps();

	$Select->Clear();
	$Select->Name = 'settings[siteDefaultTemplate]';
	$Select->SelectedValue = $mainsettings['siteDefaultTemplate'];
	foreach($Templates as $val)
	{
		$Select->AddOption($val, $val);
	}

	echo $Select->Get();

	echo '</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Default Images per Page</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">Select default images per page for site front end.</td>
	<td class="tdrow3" valign="top">';
	$Select->Clear();
	$Select->Name = 'settings[siteNumPerpage]';
	$Select->SelectedValue = $mainsettings['siteNumPerpage'];
	$Select->AddOption(5, '5');
	$Select->AddOption(10, '10');
	$Select->AddOption(15, '15');
	$Select->AddOption(20, '20');
	$Select->AddOption(30, '30');
	$Select->AddOption(40, '40');
	$Select->AddOption(50, '50');
	$Select->AddOption(60, '60');

	echo $Select->Get();

	echo '</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Admin Cookie Timeout</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">Number of seconds of idle time before you are automatically logged out of the admin panel.</td>
	<td class="tdrow3" valign="top">
	<input type="text" size="40" name="settings[adminCookieTimeout]" value="' . $mainsettings['adminCookieTimeout'] . '">
	</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Site Timezone Offset</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">Your '.APP_NAME.' Gallery site timezone offset.</td>
	<td class="tdrow3" valign="top">';

	$Select->Clear();
	$Select->Name = 'settings[siteTimezone]';
	$Select->SelectedValue = $mainsettings['siteTimezone'];
	$Select->AddOption(-12, '(GMT -12) Eniwetok,Kwajalein');
	$Select->AddOption(-11, '(GMT -11) Midway Island,Samoa');
	$Select->AddOption(-10, '(GMT -10) Hawaii');
	$Select->AddOption(-9, '(GMT -9) Alaska');
	$Select->AddOption(-8, '(GMT -8) Pacific Time(US & Canada)');
	$Select->AddOption(-7, '(GMT -7) Mountain Time(US & Canada)');
	$Select->AddOption(-6, '(GMT -6) Mexico City');
	$Select->AddOption(-5, '(GMT -5) Bogota,Lima');
	$Select->AddOption(-4, '(GMT -4) Caracas,La Paz');
	$Select->AddOption(-3, '(GMT -3) Brazil,Buenos Aires,Georgetown');
	$Select->AddOption(-2, '(GMT -2) Mid-Atlantic');
	$Select->AddOption(-1, '(GMT -1) Azores,CapeVerde Islands');
	$Select->AddOption(0, '(GMT) London,Lisbon,Casablanca');
	$Select->AddOption(1, '(GMT +1) Paris,Brussels,Copenhagen');
	$Select->AddOption(2, '(GMT +2) Kaliningrad,South Africa');
	$Select->AddOption(3, '(GMT +3) Moscow,Baghdad,Petersburg');
	$Select->AddOption(4, '(GMT +4) Abu Dhabi,Muscat,Baku,Tbilisi');
	$Select->AddOption(5, '(GMT +5) Karachi,Islamabad,Tashkent');
	$Select->AddOption(6, '(GMT +6) Almaty,Dhaka,Colombo');
	$Select->AddOption(7, '(GMT +7) Bangkok,Hanoi,Jakarta');
	$Select->AddOption(8, '(GMT +8) Beijing, HongKong, Singapore');
	$Select->AddOption(9, '(GMT +9) Tokyo,Osaka,Yakutsk');
	$Select->AddOption(10, '(GMT +10) Australia,Guam,Vladivostok');
	$Select->AddOption(11, '(GMT +11) Magadan,Solomon Islands');
	$Select->AddOption(12, '(GMT +12) Auckland,Wellington,Fiji');

	echo $Select->Get();

	echo '</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Default Format for Date</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">Format in which the date is presented, e.g. Y.m.d H:i:s</td>
	<td class="tdrow3" valign="top">
	<input type="text" size="40" name="settings[siteDateFormat]" value="' . $mainsettings['siteDateFormat'] . '">
	</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Check New Version</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">Whether allow '.APP_NAME.' check new version from Weensoft server?</td>
	<td class="tdrow3" valign="top">';

	$Radio ->Clear();
	$Radio->Name = 'settings[siteChecknew]';
	$Radio->SelectedID = $mainsettings['siteChecknew'];
	$Radio->AddOption(1, 'Yes', '&nbsp;&nbsp;');
	$Radio->AddOption(0, 'No', '&nbsp;&nbsp;');

	echo $Radio->Get();

	echo '</td></tr>';

	echo '</table>';

    EndSection();

// ##############################################################

    PrintSection('Site Settings');
    echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1" colspan="2">Turn Site On/Off</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">You may want to turn off your site while performing updates or other types of maintenance.</td>
	<td class="tdrow3" valign="top">';
	$Radio ->Clear();
	$Radio->Name = 'settings[siteActived]';
	$Radio->SelectedID = $mainsettings['siteActived'];
	$Radio->AddOption(1, 'On', '&nbsp;&nbsp;');
	$Radio->AddOption(0, 'Off', '&nbsp;&nbsp;');
	$Radio->Attributes = " onclick=\"if(this.value==0){EnableID('siteOffTitle');}else{DisableID('siteOffTitle');}\"";

	echo $Radio->Get();

	echo '</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Site Off Reason</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">A short description to users explaining why your site has been switched off(HTML allowed).</td>
	<td class="tdrow3" valign="top">
	<textarea name="settings[siteOffTitle]" rows="4" cols="36" id="siteOffTitle" '.Iif($mainsettings['siteActived'], ' disabled="disabled"').'>' . $mainsettings['siteOffTitle'] . '</textarea>
	</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Site Name</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">Name of your website.</td>
	<td class="tdrow3" valign="top">
	<input type="text" size="40" name="settings[siteCopyright]" value="' . $mainsettings['siteCopyright'] . '">
	</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Site Title</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">Title of your website pages.</td>
	<td class="tdrow3" valign="top">
	<input type="text" size="40" name="settings[siteTitle]" value="' . $mainsettings['siteTitle'] . '">
	</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Meta Keywords</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">These keywords will help your site be listed in search engines, multi-keywords separated by commas.</td>
	<td class="tdrow3" valign="top">
	<input type="text" size="40" name="settings[siteKeywords]" value="' . $mainsettings['siteKeywords'] . '">
	</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">Meta Description</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">Description of your website helps your site\'s position in search engines.</td>
	<td class="tdrow3" valign="top">
	<input type="text" size="40" name="settings[siteMeta]" value="' . $mainsettings['siteMeta'] . '">
	</td></tr>';

	echo '</table>';

    EndSection();

    PrintSection('Mail Settings');
    echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1" colspan="2">Site Email Address</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">This email address is used as the Reply address in the email sent to user by InterPhoto.</td>
	<td class="tdrow3" valign="top">
	<input type="text" size="40" name="settings[siteEmail]" value="' . $mainsettings['siteEmail'] . '">
	</td></tr>';

    echo '<tr>
	<td class="tdrow1" colspan="2">Mail Mode</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">If site server is windows system, SMTP must be selected for mailing(require the server\'s PHP Sockets enabled).
<BR><BR>PHP Mail mode is recommended if the server is Unix or Linux.</td>
	<td class="tdrow3" valign="top">';

	$Radio ->Clear();
	$Radio->Name = 'settings[siteUseSmtp]';
	$Radio->SelectedID = $mainsettings['siteUseSmtp'];
	$Radio->AddOption(0, 'PHP Mail', '&nbsp;&nbsp;');
	$Radio->AddOption(1, 'SMTP', '&nbsp;&nbsp;');
	$Radio->Attributes = " onclick=\"if(this.value==1){ShowDIV('div_smtp_settings');}else{HideDIV('div_smtp_settings');}\"";

	echo $Radio->Get();

	echo '</td></tr></table>';

	echo '<div id="div_smtp_settings" style="display: '.Iif($mainsettings['siteUseSmtp'], 'block', 'none').';"><table width="100%" border="0" cellpadding="5" cellspacing="0"><tr>
	<td class="tdrow1" colspan="2">-- SMTP Server Host</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">SMTP server hostname or IP address.</td>
	<td class="tdrow3" valign="top">
	<input type="text" size="40" name="settings[siteSmtpHost]" value="' . $mainsettings['siteSmtpHost'] . '">
	</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">-- SMTP Server Port</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">SMTP Server Port is 25 normally.</td>
	<td class="tdrow3" valign="top">
	<input type="text" size="40" name="settings[siteSmtpPort]" value="' . $mainsettings['siteSmtpPort'] . '">
	</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">-- SMTP Email Address</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">This email address is only used to send emails for SMTP server, not receives any emails.</td>
	<td class="tdrow3" valign="top">
	<input type="text" size="40" name="settings[siteSmtpEmail]" value="' . $mainsettings['siteSmtpEmail'] . '">
	</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">-- SMTP Username</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">The username used to sign up SMTP Email Address.</td>
	<td class="tdrow3" valign="top">
	<input type="text" size="40" name="settings[siteSmtpUser]" value="' . $mainsettings['siteSmtpUser'] . '">
	</td></tr>';

	echo '<tr>
	<td class="tdrow1" colspan="2">-- SMTP Password</td>
	</tr>
	<tr>
	<td class="tdrow2" width="60%">The password used to sign up SMTP Email Address.</td>
	<td class="tdrow3" valign="top">
	<input type="password" size="40" name="settings[siteSmtpPassword]" value="' . $mainsettings['siteSmtpPassword'] . '">
	</td></tr>';

	echo '</table></div>';

    EndSection();

	PrintSubmit('updatesettings', 'Save Settings');
	echo '</form>';

}


// ############################### PRINT FOOTER ################################

PrintFooter();

?>