<?php

// +---------------------------------------------+
// |     Copyright  2010 - 2018 InterPhoto       |
// |     http://www.weensoft.com                 |
// |     This file may not be redistributed.     |
// +---------------------------------------------+

include('includes/Admin.Core.php');

CheckAccess('manageupgrade');


PrintHeader('Upgrade');

$action = ForceIncomingString('action');

$upgradefinished = false;

// ############################### RUN  UPGRADES ###############################

if($action == 'upgraderunning')
{
	include(BASEPATH . 'upgrade/upgrade.php');
	$upgradefinished = UpgradeSystem();
}

if($action == 'deleteupgradefiles')
{
	@unlink(BASEPATH . 'upgrade/upgrade.php');
	@unlink(BASEPATH . 'upgrade/version.php');
}


// ############################### DISPLAY UPGRADES #############################

$availableupgrades = 0;

if(file_exists(BASEPATH . 'upgrade/upgrade.php') and file_exists(BASEPATH . 'upgrade/version.php'))
{
	$availableupgrades=1;
}

PrintSection('Update Instructions');
echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">';

echo '<tr>
<td class="tdrow1" colspan="2">';
if($availableupgrades){
	echo 'Update files checked, please run update!';
}else if($upgradefinished){
	echo 'Update successfully!';
}else{
	echo 'No any update files available!';
}
echo '</td>
</tr>
<tr>
<td class="tdrow2" width="70%" valign="top">
1. Please read a instruction document in the update package carefully after you get it.<br>
2. Normally, the update progress is: unzip the update package you got, next config FTP\'s uploading mode as "Binary Mode", then upload all files to your site and override original files, finally go to Admin Panel to upgrade.<br>
3. Deleting all files in upgrade directory is recommended for security when update over.
</td>
</tr>
<tr>
<td class="tdrow3" width="70%" valign="top" align="center">';

if($availableupgrades){
	include(BASEPATH . 'upgrade/version.php');
	$disableupgrade    = 'Disabled'; 
	
	$new = str_replace ('.', '', $InterPhotoNewVersion);
	$old = str_replace ('.', '', APP_VERSION);

	If(intval ($new) <= intval ($old)){
		$messages = '<font class=ohredb>Your InterPhoto\'s version is higher or equal to the version of update scripts, no update!</font>';
	}else{
		$messages = '';
		$disableupgrade    = 'Enabled'; 
	}
	 
	$availableupgrades++;


	if($upgradefinished){
		echo '<form method="post" action="admin.upgrade.php">
		<input type="hidden" name="action" value="deleteupgradefiles">
		<br><br><font class=ohblueb>Update successfully! Deleting all files in upgrade directory is recommended for security.</font><br><br><br>
		<input type="submit" name="deletefiles" value="Delete Update Files"><br><br>
		</form>';
	}else{
		echo '<form method="post" action="admin.upgrade.php">
		<input type="hidden" name="action" value="upgraderunning">
		Current Version: ' . APP_VERSION . ' (UTF-8)<br>
		Update Version: <font class=ohred>' . $InterPhotoNewVersion . '</font> (UTF-8)<br>
		<br><br>
		' . Iif($messages, $messages.'<br><br><br>') . '
		<input type="submit" name="upgrade" value="Run Update" '. $disableupgrade .'><br><br>
		</form>';
	}

}else{
		echo '<br><br><b>No any update files available!</b><br><br><br>';
}

echo '</td></tr></table>';

EndSection();

PrintFooter();

?>