<?php

// +---------------------------------------------+
// |     Copyright  2010 - 2018 InterPhoto       |
// |     http://www.weensoft.com                 |
// |     This file may not be redistributed.     |
// +---------------------------------------------+

include('includes/Admin.Core.php');

CheckAccess('manageuser');


PrintHeader('Manage Users');

$action = ForceIncomingString('action', 'displayusers');
if(IsPost('updateusers')) $action= 'updateusers';
if(IsPost('deleteusers')) $action= 'deleteusers';

$getusergroups = $DB->query("SELECT groupid, name FROM " . TABLE_PREFIX . "usergroups ORDER BY groupid");
while($usergroup = $DB->getrow($getusergroups)) {
	if($usergroup['groupid'] != 1) $usergroups[$usergroup['groupid']] = $usergroup['name'];
}

@set_time_limit(600);

// ################################ INSERT USER ################################

if($action == 'insertuser')
{
	$groupid     = ForceIncomingInt('groupid');
	$username        = ForceIncomingString('username');
	$password        = ForceIncomingString('password');
	$passwordconfirm = ForceIncomingString('passwordconfirm');
	$email           = ForceIncomingString('email');
	$userfullname        = ForceIncomingString('userfullname');
	$usercompany        = ForceIncomingString('usercompany');
	$useraddress        = ForceIncomingString('useraddress');
	$userpostcode        = ForceIncomingString('userpostcode');
	$usertel        = ForceIncomingString('usertel');
	$userfax        = ForceIncomingString('userfax');
	$useronline        = ForceIncomingString('useronline');
	$userwebsite        = ForceIncomingString('userwebsite');

	if(strlen($username) == 0){
		$errors[] = 'The username is empty!';
	}elseif(!IsName($username)){
		$errors[] = 'The username includes invalid characters!';
	}elseif($registered = $DB->query_first("SELECT userid FROM " . TABLE_PREFIX . "users WHERE username = '$username'")){
		Errmsg('The username already exists, please enter another one!');
	}

	if(strlen($password) == 0){
		$errors[] = 'The password is empty!';
	}elseif(!IsPass($password)){
		$errors[] = 'The password includes invalid characters!';
	}elseif($password != $passwordconfirm){
		$errors[] = 'The confirm password does not match the password!';
	}

	if(strlen($email) == 0){
		$errors[] = 'The email address is empty!';
	}elseif(!IsEmail($email)){
		$errors[] = 'The email address is invalid!';
	}elseif($DB->query_first("SELECT email FROM " . TABLE_PREFIX . "users WHERE email = '$email' ")){
		Errmsg('The email address has been occupied, please enter another one!');
	}

	if(!isset($errors))
	{
		$DB->query("INSERT INTO " . TABLE_PREFIX . "users VALUES (NULL, '$groupid', 1, '$username', '".md5($password)."', '', '$email', '".time()."', 0, '$userfullname', '$usercompany', '$useraddress', '$userpostcode', '$usertel', '$userfax', '$useronline', '$userwebsite')");

		PrintRedirect('admin.users.php', 1);
	}
	else
	{
		PrintErrors($errors, 'Add User Errors');
		$action = 'adduser';
	}
}

// ################################ UPDATE USER ################################

if($action == 'updateuser')
{
	$userid          = ForceIncomingInt('userid');
	$groupid     = ForceIncomingInt('groupid');
	$username        = ForceIncomingString('username');
	$password        = ForceIncomingString('password');
	$passwordconfirm = ForceIncomingString('passwordconfirm');
	$email           = ForceIncomingString('email');
	$activated       = ForceIncomingInt('activated');
	$userfullname        = ForceIncomingString('userfullname');
	$usercompany        = ForceIncomingString('usercompany');
	$useraddress        = ForceIncomingString('useraddress');
	$userpostcode        = ForceIncomingString('userpostcode');
	$usertel        = ForceIncomingString('usertel');
	$userfax        = ForceIncomingString('userfax');
	$useronline        = ForceIncomingString('useronline');
	$userwebsite        = ForceIncomingString('userwebsite');
	$deleteuser       = ForceIncomingInt('deleteuser');
	$deleteuserimages       = ForceIncomingInt('deleteuserimages');

	if($deleteuserimages){
		$getimages = $DB->query("SELECT imageid FROM " . TABLE_PREFIX . "images WHERE userid = '$userid' ");

		while($image = $DB->getrow($getimages)){
			DeleteImageById ($image['imageid']);
		}
	}
  
	if($deleteuser){
		if($userid == $userinfo['userid'])
		{
			$errors = "Haha, you can not delete yourself!";
			PrintErrors($errors, 'Edit User Error');
			$action = 'edituser';
		}else{
			$DB->query("DELETE FROM " . TABLE_PREFIX . "users WHERE userid = '$userid' ");
			PrintRedirect('admin.users.php', 1);
		}
	}else{

		if(strlen($username) == 0){
			$errors[] = 'The username is empty!';
		}elseif(!IsName($username)){
			$errors[] = 'The username includes invalid characters!';
		}elseif($DB->query_first("SELECT userid FROM " . TABLE_PREFIX . "users WHERE username = '$username' AND  userid != '$userid'")){
			Errmsg('The username already exists, please enter another one!');
		}

		if(strlen($password) OR strlen($passwordconfirm))
		{
			if(!IsPass($password)){
				$errors[] = 'The password includes invalid characters!';

			}elseif(strcmp($password, $passwordconfirm)){
				$errors[] = 'The confirm password does not match the password!';
			}
		}
	  
		if(strlen($email) == 0){
			$errors[] = 'The email address is empty!';
		}elseif(!IsEmail($email)){
			$errors[] = 'The email address is invalid!';
		}elseif($DB->query_first("SELECT email FROM " . TABLE_PREFIX . "users WHERE email = '$email' AND userid != '$userid'")){
			Errmsg('The email address has been occupied, please enter another one!');
		}

	  
		if(!isset($errors))	{
			$DB->query("UPDATE " . TABLE_PREFIX . "users SET username    = '$username',
			".Iif($userid != $userinfo['userid'], "groupid = '$groupid', activated = '$activated',")."
			email       = '$email',
			userfullname       = '$userfullname',
			usercompany       = '$usercompany',
			useraddress       = '$useraddress',
			userpostcode       = '$userpostcode',
			usertel       = '$usertel',
			userfax       = '$userfax',
			useronline       = '$useronline',
			userwebsite       = '$userwebsite'												 
			WHERE userid      = '$userid'");

			if(strlen($password) > 0)
			{
				$DB->query("UPDATE " . TABLE_PREFIX . "users SET password = '" . md5($password) . "' WHERE userid = '$userid'");
			}

			PrintRedirect('admin.users.php', 1);
		}else{
			PrintErrors($errors, 'Edit User Errors');
			$action = 'edituser';
		}
	}
}

// ############################### DELETE USERS ################################

if($action == 'deleteusers')
{
	$deleteuserids = ForceIncomingArray('deleteuserids');

	for($i = 0; $i < count($deleteuserids); $i++){
		if($deleteuserids[$i] != $userinfo['userid'])
		{
			$DB->query("DELETE FROM " . TABLE_PREFIX . "users WHERE userid = '" . ForceInt($deleteuserids[$i]) . "'");
		}else{
			$errors = "Haha, you can not delete yourself!";
		}
	}

	if($errors){
		PrintErrors($errors, 'Delete User Error');
		PrintRedirect('admin.users.php', 5);
	}else{
		PrintRedirect('admin.users.php', 1);
	}

}

// ############################### UPDATE USERS ################################

if($action == 'updateusers')
{
	$userids   = ForceIncomingArray('updateuserids');
	$activateds   = ForceIncomingArray('activateds');

    for($i = 0; $i < count($userids); $i++)
    {
		if($userids[$i] != $userinfo['userid']){
			$DB->query("UPDATE " . TABLE_PREFIX . "users SET activated = '$activateds[$i]' WHERE userid = '$userids[$i]'");
		}
    }

    PrintRedirect('admin.users.php', 1);

}

// ############################ DISPLAY USER FORUM #############################

if($action == 'edituser' OR $action == 'adduser')
{
	$userid = ForceIncomingInt('userid');

	if($userid){
		if(!$subcategory = $DB->query_first("SELECT userid FROM " . TABLE_PREFIX . "users WHERE userid = '$userid'")){
			PrintErrors('User does not exist!', 'Edit User Error');
		}
	}

	if(isset($errors))
	{
		// new user or edit user with errors, redisplaying the form
		$user = array('userid'   => $userid,
			  'groupid'  => Iif($userid == $userinfo['userid'], $userinfo['groupid'], $groupid),
			  'activated'  => Iif($userid == $userinfo['userid'], $userinfo['activated'], $activated),
			  'username'     => $username,
			  'email'     => $email,
			  'userfullname'     => $userfullname,
			  'usercompany'     => $usercompany,
			  'useraddress'     => $useraddress,
			  'userpostcode'     => $userpostcode,
			  'usertel'     => $usertel,
			  'userfax'     => $userfax,
			  'useronline'     => $useronline,
			  'userwebsite'     => $userwebsite);

	} else if($userid) {
		$user = $DB->query_first("SELECT * FROM " . TABLE_PREFIX . "users WHERE userid = '$userid'");
	}else{
		$user = array('userid' => 0, 'groupid' => 3, 'activated' => 1);
	}

	if($userid)
	{
		PrintSection('Edit User: ' . $user['username']);
	}else{
		PrintSection('Add User');
	}

	$message_info = '(<font class=ohred>Required</font>)';
	$message_pass = Iif($userid, '(<font class=ohgreen>Leave blank with no change</font>)', $message_info);

	echo '<form method="post" action="admin.users.php">
	<input type="hidden" name="action" value="' . Iif($userid, 'updateuser', 'insertuser') . '" />
	<input type="hidden" name="userid" value="' . $user['userid'] . '" />
	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow2" width="40%">Usergroup:</td>
	<td class="tdrow3"><select name="groupid" ' . Iif($userid == $userinfo['userid'], 'disabled') .'>';

	foreach($usergroups as $key => $value)
	{
		echo '<option value="' . $key . '" ' . Iif($user['groupid'] == $key, ' SELECTED') . '>' . $value . '</option>';
	}

	echo '</select>
	</td>
	</tr>
	<tr>
	<td class="tdrow2" width="40%">Username'.$message_info.':</td>
	<td class="tdrow3"><input type="text" name="username" value="'.$user['username'].'" size="40" /></td>
	</tr>
	<tr>
	<td class="tdrow2">Password'.$message_pass.':</td>
	<td class="tdrow3"><input type="password" name="password" size="40" /></td>
	</tr>
	<tr>
	<td class="tdrow2">Confirm Password'.$message_pass.':</td>
	<td class="tdrow3"><input type="password" name="passwordconfirm" size="40" /></td>
	</tr>
	<tr>
	<td class="tdrow2">Email Address'.$message_info.':</td>
	<td class="tdrow3"><input type="text" name="email" value="'.$user['email'].'" size="40" /></td>
	</tr>
	<tr>
	<td class="tdrow2">Full Name:</td>
	<td class="tdrow3"><input type="text" name="userfullname" value="'.$user['userfullname'].'" size="40" /></td>
	</tr>
	<tr>
	<td class="tdrow2">Company:</td>
	<td class="tdrow3"><input type="text" name="usercompany" value="'.$user['usercompany'].'" size="40" /></td>
	</tr>
	<tr>
	<td class="tdrow2">Address:</td>
	<td class="tdrow3"><input type="text" name="useraddress" value="'.$user['useraddress'].'" size="40" /></td>
	</tr>
	<tr>
	<td class="tdrow2">Post Code:</td>
	<td class="tdrow3"><input type="text" name="userpostcode" value="'.$user['userpostcode'].'" size="40" /></td>
	</tr>
	<tr>
	<td class="tdrow2">Tel:</td>
	<td class="tdrow3"><input type="text" name="usertel" value="'.$user['usertel'].'" size="40" /></td>
	</tr>
	<tr>
	<td class="tdrow2">Fax:</td>
	<td class="tdrow3"><input type="text" name="userfax" value="'.$user['userfax'].'" size="40" /></td>
	</tr>
	<tr>
	<td class="tdrow2">Online Msg:</td>
	<td class="tdrow3"><input type="text" name="useronline" value="'.$user['useronline'].'" size="40" /></td>
	</tr>
	<tr>
	<td class="tdrow2">Website:</td>
	<td class="tdrow3"><input type="text" name="userwebsite" value="'.$user['userwebsite'].'" size="40" /></td>
	</tr>';

	if($userid){
		echo '<tr>
		<td class="tdrow2">Activate This User?</td>
		<td class="tdrow3"><input type="checkbox" ' . Iif($userid == $userinfo['userid'], 'disabled') .' name="activated" value="1" ' . Iif($user['activated'] == 1, ' checked="checked"') .' /></td>
		</tr>
		<tr>
		<td class="tdrow2">Delete This User?</td>
		<td class="tdrow3"><input type="checkbox" ' . Iif($userid == $userinfo['userid'], 'disabled') .' name="deleteuser" value="1" />&nbsp;(<font class=ohredb>Select carefully</font>)</td>
		</tr>
		</tr>
		<tr>
		<td class="tdrow2">Delete All Images of This User?</td>
		<td class="tdrow3"><input type="checkbox" name="deleteuserimages" value="1" />&nbsp;(<font class=ohredb>Select carefully</font>)</td>
		</tr>';
	}
		
	echo '<tr>
	<td class="tdrow1" bgcolor="#FCFCFC" colspan="2" align="center">
	<input type="submit" value="' . Iif($userid, 'Save User', 'Add User') . '" />
	</td>
	</tr>
	</table>
	</form>';

	EndSection();
}

// ############################### DISPLAY USERS ###############################

if($action == 'displayusers')
{
	$NumPerPage =20;

	$page = ForceIncomingInt('page', 1);
	$letter = ForceIncomingString('letter');
	$searchname = ForceIncomingString('searchname');
	$searchemail = ForceIncomingString('searchemail');
	$searchgroup = ForceIncomingInt('searchgroup');

	if(IsGet('searchname') OR IsGet('searchemail') ){
		$searchname = urldecode($searchname);
		$searchemail = urldecode($searchemail);
	}

	$start = $NumPerPage * ($page-1);

	PrintSection('Quick Search');
	echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1" align="center">
	<a href="admin.users.php">All Users</a>&nbsp;&nbsp;';

	for($alphabet = 'a'; $alphabet != 'aa'; $alphabet++)
	{
		echo '<a href="admin.users.php?letter=' . $alphabet . '">' . strtoupper($alphabet) . '</a> &nbsp;';
	}

	echo '&nbsp;<a href="admin.users.php?letter=Validating">Nonactivated</a>&nbsp;
	<a href="admin.users.php?letter=Neverlogin">Neverlogin</a>&nbsp;
	<a href="admin.users.php?letter=Other">Others</a></td>
	</tr>
	</table>';
	EndSection();

	PrintSection('Search User');
	echo '<form method="post" action="admin.users.php" name="searchusers">
    <input type="hidden" name="letter" value="Search" />
	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1" align="center">Username:&nbsp;<input type="text" name="searchname" size="12">&nbsp;&nbsp;Email:&nbsp;<input type="text" name="searchemail" size="16">&nbsp;&nbsp;Usergroup:&nbsp;<select name="searchgroup"><option value="0">All Usergroups</option>';

	foreach($usergroups as $key => $value)
	{
		echo '<option value="' . $key . '">' . $value . '</option>';
	}

	echo '</select>&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" value="Search" /></td>
	</tr>
	</table></form>';
	EndSection();

	if(isset($letter) AND $letter != '')
	{
		if($letter == 'Other')
		{
			$getusers = $DB->query("SELECT userid, groupid, username, email, activated, joindate, lastactivity FROM " . TABLE_PREFIX . "users WHERE username NOT REGEXP(\"^[a-zA-Z]\") ORDER BY userid DESC LIMIT $start,$NumPerPage");
			$title = 'Users with Non-English Username';
			$maxrows = $DB->query_first("SELECT COUNT(userid) AS value FROM " . TABLE_PREFIX . "users WHERE username NOT REGEXP(\"^[a-zA-Z]\")");
		}
		else if($letter == 'Validating')
		{
			$getusers = $DB->query("SELECT userid, groupid, username, email, activated, joindate, lastactivity FROM " . TABLE_PREFIX . "users WHERE activated = 0 ORDER BY userid DESC LIMIT $start,$NumPerPage");
			$title = 'Nonactivated Users';
			$maxrows = $DB->query_first("SELECT COUNT(userid) AS value FROM " . TABLE_PREFIX . "users WHERE activated = 0");
		}
		else if($letter == 'Search')
		{
			$getusers = $DB->query("SELECT userid, groupid, username, email, activated, joindate, lastactivity FROM " . TABLE_PREFIX . "users WHERE LOWER(username) LIKE '%".$searchname."%' AND LOWER(email) LIKE '%".$searchemail."%' ".Iif($searchgroup, " AND groupid = '$searchgroup'")." ORDER BY userid DESC LIMIT $start,$NumPerPage");
			$title = 'Users by Searching';
			$maxrows = $DB->query_first("SELECT COUNT(userid) AS value FROM " . TABLE_PREFIX . "users WHERE LOWER(username) LIKE '%".$searchname."%' AND LOWER(email) LIKE '%".$searchemail."%' ".Iif($searchgroup, " AND groupid = '$searchgroup'"));
		}
		else if($letter == 'Neverlogin')
		{
			$getusers = $DB->query("SELECT userid, groupid, username, email, activated, joindate, lastactivity FROM " . TABLE_PREFIX . "users WHERE lastactivity = 0 ORDER BY userid DESC LIMIT $start,$NumPerPage");
			$title = 'Neverlogin Users';
			$maxrows = $DB->query_first("SELECT COUNT(userid) AS value FROM " . TABLE_PREFIX . "users WHERE lastactivity = 0");
		}
		else
		{
			$getusers = $DB->query("SELECT userid, groupid, username, email, activated, joindate, lastactivity FROM " . TABLE_PREFIX . "users WHERE LOWER(username) LIKE '".$letter."%' ORDER BY userid DESC LIMIT $start,$NumPerPage");
			$title = 'Users with username started by ' . strtoupper($letter);
			$maxrows = $DB->query_first("SELECT COUNT(userid) AS value FROM " . TABLE_PREFIX . "users WHERE LOWER(username) LIKE '".$letter."%'");
		}
    
	}else{
		$title = 'All Users';
		$getusers = $DB->query("SELECT userid, groupid, username, email, activated, joindate, lastactivity FROM " . TABLE_PREFIX . "users ORDER BY userid DESC LIMIT $start,$NumPerPage");
		$maxrows = $DB->query_first("SELECT COUNT(userid) AS value FROM " . TABLE_PREFIX . "users");
	}

	echo '&nbsp;&nbsp;&nbsp;&nbsp;<a href="admin.users.php?action=adduser"><img src="'.TEMPLATEPATH.'images/open.gif" align="absmiddle"> <font class=ohblueb><u>Add User</u></font></a>';

	PrintSection($title.' ('.$maxrows['value'].')');

	echo '<form method="post" action="admin.users.php" name="deleteusers">
	<table width="100%" border="0" cellpadding="5" cellspacing="0">
	<tr>
	<td class="tdrow1" nowrap="nowrap">Username</td>
	<td class="tdrow1" nowrap="nowrap">Usergroup</td>
	<td class="tdrow1" nowrap="nowrap">Status</td>
	<td class="tdrow1" nowrap="nowrap">Images</td>
	<td class="tdrow1" nowrap="nowrap">Email</td>
	<td class="tdrow1" nowrap="nowrap">Join Date</td>
	<td class="tdrow1" nowrap="nowrap">Last Login</td>
	<td class="tdrow1" nowrap="nowrap"><input type="checkbox" checkall="group" onclick="javascript: return select_deselectAll (\'deleteusers\', this, \'group\');"> Delete</td>
	</tr>';

	if($maxrows['value'] < 1){
		echo '<tr><td class="tdrow3" colspan="8" align="center" height="48" valign="middle"><font class=ohredb>No any users found!</font></td></tr>';
	}else{
		while($user = $DB->getrow($getusers))
		{
			
			$totalimages = $DB->query_first("SELECT COUNT(imageid) AS value FROM " . TABLE_PREFIX . "images WHERE userid = '" . $user['userid'] . "'");

			echo '<tr>
			<td class="tdrow2"><input type="hidden" name="updateuserids[]" value="'.$user['userid'].'" />
			<a href="admin.users.php?action=edituser&userid='.$user['userid'].'">
			'.Iif($user['activated'] != '1','<font class=ohred><u>').$user['username'].Iif($user['activated'] != '1','</u></font>').'</a>
			</td>
			<td class="tdrow3">' . $usergroups[$user['groupid']] . '</td>
			<td class="tdrow2">
			<select name="activateds[]"  ' . Iif($user['userid'] == $userinfo['userid'], 'disabled') .'>
			<option value="1">Activated</option>
			<option style="color:red;" value="0" ' . Iif(!$user['activated'], 'SELECTED', '') . '>Nonactivated</option>
			</select>
			</td>
			<td class="tdrow3">' . $totalimages['value'] . '</td>
			<td class="tdrow2">' . Iif($user['userid'] != $userinfo['userid'], '<a href="mailto:' . $user['email'] . '">' . $user['email'] . '</a>', $user['email']) . '</td>
			<td class="tdrow3">' . DisplayDate($user['joindate'], 'Y-m-d') . '</td>
			<td class="tdrow2">';

			if($user['lastactivity'] == 0)
			{
				echo '<span class="ohorange">Neverlogin</span>';
			}
			else 
			{
				echo DisplayDate($user['lastactivity'], 'Y-m-d');
			}

			echo '</td>
			<td class="tdrow3"><input type="checkbox" name="deleteuserids[]" value="' . $user['userid'] . '" checkme="group" ' . Iif($user['userid'] == $userinfo['userid'], 'disabled') .'/></td>
			</tr>';
		}
	}

	$totalpages = ceil($maxrows['value'] / $NumPerPage);

	if($totalpages > 1){
		echo '<tr><td class="tdrow3" colspan="8" align="center" height="48" valign="middle">';
		echo GetPageList('admin.users.php', $totalpages, $page, 10, 'letter', $letter, 'searchname', urlencode($searchname), 'searchemail', urlencode($searchemail), 'searchgroup', $searchgroup);
		echo '</td></tr>';
	}

	echo '<tr><td class="tdrow1" colspan="8" align="center"><input type="submit" name="updateusers" value="Save Users" />&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" name="deleteusers" onclick="return confirm(\'Are you sure to delete all the users selected?\r\n\r\nRe: The images of users will not be deleted!\');" value="Delete Users" /></td></tr></table></form>';

	EndSection();
}


// ############################### PRINT FOOTER ################################

PrintFooter();

?>