<?php

// +---------------------------------------------+
// |     Copyright  2010 - 2018 InterPhoto       |
// |     http://www.weensoft.com                 |
// |     This file may not be redistributed.     |
// +---------------------------------------------+


include('includes/InterPhoto.Core.php');

$smarty = new InterPhoto;

$allcategories = array();


function GetAllCategories($parentid, $sublevelmarker = ''){
	global $DB, $allcategories;

	if($parentid != 0){
		$sublevelmarker .= '&nbsp;&nbsp;&nbsp;&nbsp;';
	}

	$getcategories = $DB->query("SELECT categoryid, parentid, title FROM " . TABLE_PREFIX . "categories WHERE parentid = $parentid ORDER BY ordernum");

	while($category = $DB->getrow($getcategories))
	{
		$allcategories[$category['categoryid']] = $sublevelmarker . ShortTitle($category['title'], 12);
		GetAllCategories($category['categoryid'], $sublevelmarker);
	}
}


function GetCategorySelect($selectname, $selectedid = 0){
	global $DB, $allcategories, $sys_langs;

	$sReturn = '<select name="'.$selectname.'" onchange="if(this.options[this.selectedIndex].value>=0) {document.location=\''. GetUrl('index.php') . '?c=\'+this.options[this.selectedIndex].value;}">';
	$sReturn .= '<option value="0">'.$sys_langs['allcategory']  . ' (' . GetImageCounts(0) . ')</option>';

	foreach($allcategories as $key => $value)
	{
		$imagescount = GetImageCounts($key);
		$thiskey = Iif($imagescount, $key, -1);
		$sReturn .= '<option value="' . $thiskey . '" ' . Iif($selectedid == $key, ' SELECTED') . '>' . $value  . ' (' .$imagescount . ')</option>';
	}

	$sReturn .= '</select>';

	return $sReturn;
	
}



GetAllCategories(0);

$categoryid = ForceIncomingInt('c');
$categoryselect = GetCategorySelect('categoryselect', $categoryid);


$page = ForceIncomingInt('p', 1);
$search = ForceIncomingString('s');

$NumPerPage = ForceInt(ForceIncomingCookie('IPP'.COOKIE_KEY), ForceInt($mainsettings['siteNumPerpage'], 10));
$orderby = ForceIncomingCookie('IPS'.COOKIE_KEY);

if($categoryid){
	$thiscategory = $DB->query_first("SELECT parentid, title, keywords, sorting FROM " . TABLE_PREFIX . "categories WHERE actived = 1 AND categoryid = $categoryid ");
	$categorysql .= " AND i.categoryid = $categoryid ";

	if($thiscategory){
		$categorylinks = Iif($thiscategory['parentid'], GetCategorylinks($thiscategory['parentid'])) . ' '. $langs['nav'].' <a href="'.GetUrl('index.php', 'c', $categoryid).'">'.ShortTitle($thiscategory['title'], 18).'</a>';
	}

	$smarty->assign('pagetitle', $thiscategory['title'] . ' - ' .$mainsettings['siteTitle']);
	if($thiscategory['keywords']){
		$smarty->assign('metakeywords', $thiscategory['keywords'] . ',' .$mainsettings['siteKeywords']);
		$smarty->assign('metadescription', $thiscategory['keywords'] . ',' .$mainsettings['siteMeta']);
	}

	if(!$orderby){
		$orderby = $thiscategory['sorting'];
	}
}

$orderbysql = " ORDER BY ";

switch ($orderby)
{
	case 'tdown':
		$orderbysql .= " i.imageid DESC ";
		break;
	case 'tup':
		$orderbysql .= " i.imageid ASC ";
		break;
	case 'vdown':
		$orderbysql .= " i.viewcount DESC ";
		break;
	case 'vup':
		$orderbysql .= " i.viewcount ASC ";
		break;
	case 'ddown':
		$orderbysql .= " i.downloadcount DESC ";
		break;
	case 'dup':
		$orderbysql .= " i.downloadcount ASC ";
		break;
	case 'oup':
		$orderbysql .= " i.ordernum ASC ";
		break;
	default:
		$orderbysql .= " i.ordernum DESC ";
		break;
}

if($search){
	$search = SafeSearchSql(Iif(IsGet('s'), urldecode($search), $search));

	$keywords = explode (' ', str_replace(array('+', ',' , ';'), ' ', $search) );
	foreach ($keywords as $key => $value) {
		$searchsql .= " AND (i.username LIKE '%".$value."%' OR i.title LIKE '%".$value."%' OR i.description LIKE '%".$value."%' OR i.keywords LIKE '%".$value."%') ";
	}
}

$start = $NumPerPage * ($page-1);

$getimages = $DB->query("SELECT i.imageid, i.categoryid, i.path, i.filename, i.title, i.viewcount, i.downloadcount, i.created, c.title AS categorytitle FROM " . TABLE_PREFIX . "images i LEFT JOIN  " . TABLE_PREFIX . "categories c ON (c.categoryid = i.categoryid) WHERE (i.usergroupids = 'all' OR i.usergroupids LIKE '%(".$userinfo['groupid'].")%') AND i.actived = 1 AND c.actived = 1 " .$categorysql. $searchsql . $orderbysql ." LIMIT $start,$NumPerPage");
$maxrows = $DB->query_first("SELECT COUNT(i.imageid) AS value FROM " . TABLE_PREFIX . "images i LEFT JOIN  " . TABLE_PREFIX . "categories c ON (c.categoryid = i.categoryid) WHERE (i.usergroupids = 'all' OR i.usergroupids LIKE '%(".$userinfo['groupid'].")%') AND i.actived = 1 AND c.actived = 1 ".$categorysql.$searchsql);
$images = $DB->getrows($getimages);

$totalpages = ceil($maxrows['value'] / $NumPerPage);

$pagenav = '<a href="'.GetUrl('index.php').'">'.$langs['home'].'</a>'
	.$categorylinks
	.Iif($search, ' '.$langs['nav'].' <span class=blackb>'.$langs['search'].'</span>: <span class=red>'. $search. '</span>&nbsp;&nbsp;(' . $maxrows['value'] . $langs['results'] . ')');

$searchquery = Iif($search, 's='.urlencode($search));

$smarty->assign('pagenav', $pagenav);
$smarty->assign('orderby', $orderby);
$smarty->assign('searchquery', $searchquery);
$smarty->assign('numperpage', $NumPerPage);
$smarty->assign('categoryselect', $categoryselect);
$smarty->assign('categoryid', $categoryid);
$smarty->assign('userinfo', $userinfo);

if(!$maxrows['value']){
	$errors = $sys_langs['noimages'];
}else{
	$smarty->assign('pagelist', GetPageList('index.php', $totalpages, $page, 10, 'c', $categoryid, 's', urlencode($search)));
	$smarty->assign('images', $images);
}

$smarty->interPlay('index.tpl');

?>