DROP TABLE IF EXISTS `InterPhoto_images`;

CREATE TABLE `InterPhoto_images` (
  `imageid` int(30) NOT NULL auto_increment,
  `ordernum` int(30) NOT NULL default '0',
  `categoryid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `username` varchar(64) NOT NULL default '',
  `actived` TINYINT(1) NOT NULL default '1',
  `watermark` TINYINT(1) NOT NULL default '1',
  `sale` TINYINT(1) NOT NULL default '0',
  `recommend` TINYINT(1) NOT NULL default '0',
  `usergroupids` text NOT NULL,
  `path` VARCHAR(36) NOT NULL default '',
  `filename` varchar(255) NOT NULL default '',
  `price` VARCHAR(36) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `tags` varchar(255) NOT NULL default '',
  `keywords` varchar(255) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `viewcount` int(30) NOT NULL default '0',
  `downloadcount` int(30) NOT NULL default '0',
  `created` int(11) NOT NULL default '0',
  PRIMARY KEY  (`imageid`),
  KEY `categoryid` (`categoryid`),
  KEY `userid` (`userid`)
) TYPE=MyISAM;


DROP TABLE IF EXISTS `InterPhoto_gimages`;

CREATE TABLE `InterPhoto_gimages` (
  `gimageid` int(30) NOT NULL auto_increment,
  `imageid` int(30) NOT NULL default '0',
  `actived` TINYINT(1) NOT NULL default '1',
  `path` VARCHAR(36) NOT NULL default '',
  `filename` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`gimageid`),
  KEY `imageid` (`imageid`)
) TYPE=MyISAM;


DROP TABLE IF EXISTS `InterPhoto_categories`;

CREATE TABLE `InterPhoto_categories` (
  `categoryid` int(11) NOT NULL auto_increment,
  `parentid` int(11) NOT NULL default '0',
  `ordernum` int(11) NOT NULL default '0',
  `actived` TINYINT(1) NOT NULL default '1',
  `title` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `keywords` varchar(255) NOT NULL default '',
  `datasize` int(20) NOT NULL default '0',
  `sorting` varchar(16) NOT NULL default 'timedown',
  `watermark` TINYINT(1) NOT NULL default '1',
  `watermarkpos` TINYINT(1) NOT NULL default '0',
  PRIMARY KEY  (`categoryid`),
  KEY `parentid` (`parentid`)
) TYPE=MyISAM;

INSERT INTO `InterPhoto_categories` (`categoryid`, `parentid`, `ordernum`, `actived`, `title`, `description`, `keywords`, `datasize`, `sorting`, `watermark`, `watermarkpos`) VALUES 
(1, 0, 1, 1, 'Default Category', 'Description for this category', 'Image,Photo,Download', '2048', 'odown', 1, 0);


DROP TABLE IF EXISTS `InterPhoto_mainsettings`;

CREATE TABLE `InterPhoto_mainsettings` (
  `settingid` INT(11) NOT NULL auto_increment,
  `varname` VARCHAR(64) NOT NULL DEFAULT '',
  `value` TEXT NOT NULL,
  PRIMARY KEY  (`settingid`)
) TYPE=MyISAM;

INSERT INTO `InterPhoto_mainsettings` (`settingid`, `varname`, `value`) VALUES 
(NULL, 'adminCookieTimeout', '1800'),
(NULL, 'siteAllowRegister', '1'),
(NULL, 'siteAllowGuest', '1'),
(NULL, 'siteRegisterCheck', 'Auto'),
(NULL, 'siteDefaultLang', 'English'),
(NULL, 'siteDefaultTemplate', 'InterPhoto'),
(NULL, 'siteNumPerpage', '10'),
(NULL, 'siteActived', '1'),
(NULL, 'siteChecknew', '0'),
(NULL, 'siteRewrite', '0'),
(NULL, 'siteTimezone', '8'),
(NULL, 'siteDateFormat', 'Y-m-d H:i:s'),
(NULL, 'siteOffTitle', 'The website is under maintaining now, please visit later, thanks!'),
(NULL, 'siteTitle', 'InterPhoto Gallery'),
(NULL, 'siteCopyright', 'InterPhoto Gallery'),
(NULL, 'siteKeywords', 'InterPhoto,Image Gallery,Image Website System'),
(NULL, 'siteMeta', 'InterPhoto,Image Gallery,Image Website System'),
(NULL, 'siteEmail', 'mail@demo.com'),
(NULL, 'siteUseSmtp', '0'),
(NULL, 'siteSmtpHost', 'smtp.yoursite.com'),
(NULL, 'siteSmtpEmail', 'yourname@yoursite.com'),
(NULL, 'siteSmtpPort', '25'),
(NULL, 'siteSmtpUser', 'yourname'),
(NULL, 'siteSmtpPassword', ''),
(NULL, 'siteAppVersion', '2.0.0'),
(NULL, 'siteAppName', 'SW50ZXJQaG90bw==');


DROP TABLE IF EXISTS `InterPhoto_usergroups`;

CREATE TABLE `InterPhoto_usergroups` (
  `groupid` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `allowview` TINYINT(1) NOT NULL default '1',
  `allowlogin` TINYINT(1) NOT NULL default '0',
  `allowupload` TINYINT(1) NOT NULL default '0',
  `allowcomment` TINYINT(1) NOT NULL default '0',
  `allowdownload` TINYINT(1) NOT NULL default '0',
  `allowdelete` TINYINT(1) NOT NULL default '0',
  `allowuploadshow` TINYINT(1) NOT NULL default '0',
  `allowcommentshow` TINYINT(1) NOT NULL default '0',
  `manage` TINYINT(1) NOT NULL default '0',
  `managesetting` TINYINT(1) NOT NULL default '0',
  `managecomment` TINYINT(1) NOT NULL default '0',
  `managecategory` TINYINT(1) NOT NULL default '0',
  `manageuser` TINYINT(1) NOT NULL default '0',
  `manageusergroup` TINYINT(1) NOT NULL default '0',
  `managenews` TINYINT(1) NOT NULL default '0',
  `managenotice` TINYINT(1) NOT NULL default '0',
  `managelanguage` TINYINT(1) NOT NULL default '0',
  `manageimage` TINYINT(1) NOT NULL default '0',
  `managedatabase` TINYINT(1) NOT NULL default '0',
  `managetemplate` TINYINT(1) NOT NULL default '0',
  `manageupgrade` TINYINT(1) NOT NULL default '0',
  PRIMARY KEY  (`groupid`)
) TYPE=MyISAM;

INSERT INTO `InterPhoto_usergroups`  (`groupid`, `name`, `allowview`, `allowlogin`, `allowupload`, `allowcomment`, `allowdownload`, `allowdelete`, `allowuploadshow`, `allowcommentshow`, `manage`, `managesetting`, `managecomment`, `managecategory`, `manageuser`, `manageusergroup`, `managenews`, `managenotice`, `managelanguage`, `manageimage`, `managedatabase`, `managetemplate`, `manageupgrade`) VALUES 
(1,'Guest',1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0),
(2,'Banned',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(3,'Member',1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0),
(4,'Administrator',1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);


DROP TABLE IF EXISTS `InterPhoto_users`;

CREATE TABLE `InterPhoto_users` (
  `userid` int(11) NOT NULL auto_increment,
  `groupid` int(11) NOT NULL,
  `activated` TINYINT(1) NOT NULL default '0',
  `username` varchar(64) NOT NULL default '',
  `password` varchar(64) NOT NULL default '',
  `verifycode` varchar(8) NOT NULL default '',
  `email` varchar(128) NOT NULL default '',
  `joindate` int(11) NOT NULL default '0',
  `lastactivity` int(11) NOT NULL default '0',
  `userfullname` varchar(128) NOT NULL default '',
  `usercompany` varchar(225) NOT NULL default '',
  `useraddress` varchar(255) NOT NULL default '',
  `userpostcode` varchar(32) NOT NULL default '',
  `usertel` varchar(255) NOT NULL default '',
  `userfax` varchar(255) NOT NULL default '',
  `useronline` varchar(255) NOT NULL default '',
  `userwebsite` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`userid`),
  KEY `groupid` (`groupid`)
) TYPE=MyISAM;


DROP TABLE IF EXISTS `InterPhoto_sessions`;

CREATE TABLE `InterPhoto_sessions` (
  `sessionid` CHAR(64) NOT NULL default '',
  `userid` int(11) default '0',
  `ipaddress` varchar(64) NOT NULL default '',
  `useragent` varchar(255) NOT NULL default '',
  `lastactivity` int(11) NOT NULL default '0',
  `location` TINYINT(1) NOT NULL default '0',
  `loggedin` TINYINT(1) NOT NULL default '0',
  `admin` TINYINT(1) NOT NULL default '0',
  PRIMARY KEY  (`sessionid`),
  KEY `userid` (`userid`)
) TYPE=MyISAM;


DROP TABLE IF EXISTS `InterPhoto_vvc`;

CREATE TABLE `InterPhoto_vvc` (
  `vvcid` int(30) NOT NULL auto_increment,
  `code` varchar(9) NOT NULL default '',
  `date` int(11) NOT NULL default '0',
  PRIMARY KEY  (`vvcid`)
) TYPE=MyISAM;



DROP TABLE IF EXISTS `InterPhoto_comments`;

CREATE TABLE `InterPhoto_comments` (
  `commentid` int(30) NOT NULL auto_increment,
  `imageid` int(30) NOT NULL default '0',
  `actived` TINYINT(1) NOT NULL default '0',
  `username`  VARCHAR(64)  NOT NULL default '',
  `content` text NOT NULL,
  `created` int(11) NOT NULL default '0',
  PRIMARY KEY  (`commentid`),
  KEY `imageid` (`imageid`)
) TYPE=MyISAM;


DROP TABLE IF EXISTS `InterPhoto_contents`;

CREATE TABLE `InterPhoto_contents` (
  `contentid` int(30) NOT NULL auto_increment,
  `username`  VARCHAR(64)  NOT NULL default '',
  `title` VARCHAR(255) NOT NULL default '',
  `content` MEDIUMTEXT NOT NULL,
  `keywords` varchar(255) NOT NULL default '',
  `created` int(11) NOT NULL default '0',
  PRIMARY KEY  (`contentid`)
) TYPE=MyISAM;

INSERT INTO `InterPhoto_contents`  (`contentid`, `username`, `title`, `content`, `keywords`, `created`) VALUES 
(1,'Admin','About Us','Please enter details for About Us on MP(manage panel).','about,us','1265951785'),
(2,'Admin','Contact Us','Please enter details for Contact Us on MP(manage panel).','contact,us','1265951785');


DROP TABLE IF EXISTS `InterPhoto_news`;

CREATE TABLE `InterPhoto_news` (
  `newid` int(30) NOT NULL auto_increment,
  `ordernum` int(30) NOT NULL default '0',
  `actived` TINYINT(1) NOT NULL default '0',
  `username`  VARCHAR(64)  NOT NULL default '',
  `title` VARCHAR(255) NOT NULL default '',
  `content` MEDIUMTEXT NOT NULL,
  `keywords` varchar(255) NOT NULL default '',
  `viewcount` int(30) NOT NULL default '0',
  `created` int(11) NOT NULL default '0',
  PRIMARY KEY  (`newid`)
) TYPE=MyISAM;


DROP TABLE IF EXISTS `InterPhoto_tags`;

CREATE TABLE `InterPhoto_tags` (
  `tagid` int(30) NOT NULL auto_increment,
  `tag` VARCHAR(255) NOT NULL default '',
  PRIMARY KEY  (`tagid`)
) TYPE=MyISAM;

